InitSprite()
InitKeyboard()
InitMouse()


If OpenScreen(800,600,32,"TEST") = 0    ; test 32bit
 If OpenScreen(800,600,24,"TEST") = 0   ; if 32bit failed, test 24bit
  If OpenScreen(800,600,16,"TEST") = 0  ; if 32/24 failed, try 16bit screen
     MessageRequester("ERROR","Cant open 16/24/32bit Screen",0):End
  EndIf
 EndIf
EndIf

Global big.AnimSprite, small.AnimSprite, explosion.AnimSprite, ship.AnimSprite
;Linux
CompilerIf #PB_Compiler_OS = #PB_OS_Linux 
  DefType.l elapsed_us,timer
CompilerEndIf
   ; limit Speed
   SetFrameRate(60)

   ; Load Anim-Sprites
   LoadSprite(1,"big.bmp",0)
   TransparentSpriteColor(1,255,0,255)
   CreateAnimSprite(big.AnimSprite,1,75,75)

   LoadSprite(2,"explosion.bmp",0)
   TransparentSpriteColor(2,255,0,255)
   CreateAnimSprite(explosion.AnimSprite,2,50,50)

   LoadSprite(3,"ship.bmp",0)
   TransparentSpriteColor(3,255,0,255)
   CreateAnimSprite(ship.AnimSprite,3,40,40)

Procedure TimerProcedure()
Shared TimerProcedure_count
       NextAnimFrame(big)
       If TimerProcedure_count = 3 Or TimerProcedure_count = 6
          NextAnimFrame(explosion)
       EndIf
TimerProcedure_count + 1
If TimerProcedure_count = 7: TimerProcedure_count = 1: EndIf
EndProcedure

CompilerIf #PB_Compiler_OS = #PB_OS_Linux 
  timer=g_timer_new_();
CompilerEndIf 



CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  StartTimer(1,50,@TimerProcedure())
CompilerEndIf 
; Variables
Repeat
     FlipBuffers()
     If IsScreenActive()
       ClearScreen(R,G,B)
       R = 0 : G = 0 : B = 0

       ; Animate Sprites
       
       DisplayAnimSprite(big,10,10)
       DisplayAnimSprite(explosion,300,400)
       DisplayAnimSprite(ship,10,300)
       
       ; KEYBOARD CHECK
       ;
       ExamineKeyboard()
       If KeyboardPushed(#PB_Key_Right) And (TimerProcedure_count = 2 Or TimerProcedure_count = 4 Or TimerProcedure_count = 6)
          PrevAnimFrame(ship)
          ;Direction = 1: ;SetFrame(Sonic,1)
          ;SonicX + 8
          ;If SonicX > 800: SonicX = -40: EndIf
       EndIf
       If KeyboardPushed(#PB_Key_Left) And (TimerProcedure_count = 2 Or TimerProcedure_count = 4 Or TimerProcedure_count = 6)
          NextAnimFrame(ship)
          ;Direction = 2: ;SetFrame(Sonic,8)
          ;SonicX - 8
          ;If SonicX < -40: SonicX = 800: EndIf
       EndIf
       If KeyboardPushed(#PB_Key_Up)
          ;SonicY - 8
          ;If SonicY < -40: SonicY = 600: EndIf
       EndIf
       If KeyboardPushed(#PB_Key_Down)
          ;SonicY + 8
          ;If SonicY > 600: SonicY = -40: EndIf
       EndIf
        
       CompilerIf #PB_Compiler_OS = #PB_OS_Linux 
         g_timer_elapsed_(timer,@elapsed_us)
         If elapsed_us>50000
            g_timer_reset_(timer)
            TimerProcedure()
         EndIf   
       CompilerEndIf 
             
       ExamineKeyboard()
       Delay(1)
   Else
       Delay(200)
   EndIf
Until KeyboardPushed(#PB_Key_Escape) 
End
