If InitSprite() = 0 Or InitKeyboard() = 0 Or InitMouse() = 0
   MessageRequester("ERROR","Cant init DirectX",0):End
EndIf

If OpenScreen(800,600,32,"TEST") = 0      ; test 32bit
  If OpenScreen(800,600,24,"TEST") = 0    ; if 32bit failed, test 24bit
    If OpenScreen(800,600,16,"TEST") = 0  ; if 32/24 failed, try 16bit screen
      MessageRequester("ERROR","Cant open 16/24/32bit Screen",0):End
    EndIf
  EndIf
EndIf


   ; Load Anim-Sprites
   CatchSprite(1,?Sonic,0)
   TransparentSpriteColor(1,255,0,255)
   CreateAnimSprite(Sonic.AnimSprite,1,40,40)

   CatchSprite(2,?Rings,0)
   CreateAnimSprite(Rings.AnimSprite,2,16,16,80)

   CatchSprite(3,?MouseCursor,0)
   CreateAnimSprite(MouseCursor.AnimSprite,3,64,64,40)


; Variables
SonicX = 80
SonicY = 200
Dim RingsX(100)
Dim RingsY(100)
Dim RingsHideFlag(100)

Procedure GetStartTime()
   ;ProcedureReturn timeGetTime_()
EndProcedure

Procedure CheckElapsedTime(initvalue,milliseconds)
   ;x = timeGetTime_()
   If x => initvalue + milliseconds
     ProcedureReturn 1
   Else
     ProcedureReturn 0
   EndIf
EndProcedure

; Init Position of Rings
For a = 1 To 100
   RingsX(a) = Random(800-16)
   RingsY(a) = Random(600-16)
Next a

   ;SetFrameRate(10)

Repeat
     FlipBuffers()
     ExamineKeyboard()

       ClearScreen(R,G,B)
       R = $00 : G = $00 : B = $00

       ; Display Rings
       For a = 1 To 100
        If RingsHideFlag(a) = 0
          DisplayAnimSprite(Rings,RingsX(a),RingsY(a))
        EndIf
       Next a

       ; Display Sonic
       DisplayAnimSprite(Sonic,SonicX,SonicY)

       ; Display mouse cursor
       If ExamineMouse()
         MouseX = MouseX() : MouseY = MouseY()
         If MouseX > 800-64 : MouseX = 800-64 : EndIf
         If MouseY > 600-64 : MouseY = 600-64 : EndIf
         DisplayAnimSprite(MouseCursor,MouseX,MouseY)
       EndIf

       ; KEYBOARD CHECK
       ;
       If InMove = 0
         If KeyboardPushed(#PB_Key_Right)
           If CurrentAnimDirection(Sonic) <> 1
             SetAnimDirection(Sonic,1)
             FrameCounter1 = GetStartTime()
             directionchanged = 1
           Else
             If directionchanged
               If CheckElapsedTime(FrameCounter1,200)
                 directionchanged = 0
               EndIf
             Else
               InMove = 1 : FrameCounter1 = GetStartTime()
             EndIf
           EndIf
            ;If SonicX > 800: SonicX = -40: EndIf
         ElseIf KeyboardPushed(#PB_Key_Left)
            SetAnimDirection(Sonic,2)
            InMove = 1
            FrameCounter1 = GetStartTime()
            ;If SonicX < -40: SonicX = 800: EndIf
         EndIf
       EndIf

       If InMove
         If CurrentAnimFrame(Sonic) < 8
           If CheckElapsedTime(FrameCounter1,100)
             NextAnimFrame(Sonic)
             FrameCounter1 = GetStartTime()
             If CurrentAnimDirection(Sonic) = 1
               SonicX + 10
               If SonicX > 800: SonicX = -40: EndIf
             Else
               SonicX - 10
               If SonicX < -40: SonicX = 800: EndIf
             EndIf
           EndIf
         Else
            SetAnimFrame(Sonic,1)
            InMove = 0
         EndIf
       EndIf

         If KeyboardPushed(#PB_Key_Up)
            SonicY - 4
            If SonicY < -40: SonicY = 600: EndIf
         EndIf
         If KeyboardPushed(#PB_Key_Down)
            SonicY + 4
            If SonicY > 600: SonicY = -40: EndIf
         EndIf

   all = 0
   ; Collision Detection
   For a = 1 To 100
       If RingsHideFlag(a) = 0
          all + 1
          If CollisionAnimAnim(Sonic,SonicX,SonicY,Rings,RingsX(a),RingsY(a))
             R = 100 : G = 100 : B = 100 : RingsHideFlag(a) = 1
          EndIf

       EndIf
   Next a
   CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      If all = 0: Beep_(1400,500): Quit = 1: EndIf
   CompilerEndIf 
Until KeyboardPushed(#PB_Key_Escape) Or Quit = 1
End

Sonic:
IncludeBinary "SonicNew.bmp"
Rings:
IncludeBinary "rings.bmp"
MouseCursor:
IncludeBinary "mineanim.bmp"