If OpenWindow(0, 0, 0, 200, 200, #PB_Window_ScreenCentered | #PB_Window_TitleBar | #PB_Window_SystemMenu, "Global hotkeys") And CreateStatusBar(0, WindowID(0))
  StatusBarText(0, 0, "Type Alt+A or Alt+B")
  ; We create the hotkeys, and display an error box if it is impossible to create one or the two.
  If AddHotkey(0, #MOD_ALT, #PB_Shortcut_A, 0) = 0
    MessageRequester("Error", "Cannot create hotkey 0.")
  ElseIf AddHotkey(0, #MOD_ALT, #PB_Shortcut_B, 1) = 0
    MessageRequester("Error", "Cannot create hotkey 1.")
  EndIf
  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_Hotkey ; If an hotkey was called
        Select EventwParam() ; For know what hotkey was called, no documentation on PureBasic for this function.
          Case 0 ; Hotkey with ID 0 (Alt+A)
            MessageRequester("Info", "Hotkey 0!")
          Case 1 ; Hotkey with ID 1 (Alt + B)
            MessageRequester("Info", "Hotkey 1!")
        EndSelect
      Case #PB_EventCloseWindow
        End
    EndSelect
    Delay(1)
  ForEver
  ; Now we remove the hotkeys.
  RemoveHotkey(0, 0)
  RemoveHotkey(0, 1)
EndIf
End