; ========================================================
; Check out Cheetah Databases with PureBasic
; ========================================================

;Use the Cheetah Include file
XIncludeFile "xdb.pb"

 Result=  xdb_INIT() ; Use Cheetah library
; Debug Result



  ;xdbActivate(#X1)

;==================================================================================================

; Define the names of the database & index
  DBFname.s = "Cheetah.dbf"                ;THIS IS A DBF DATABASE I HAVE (ANY DBF COULD BE USED)
  ;IDXname.s = "AcctDEX.idx"                ;INDEXES ARE BASED ON THE ABOVE FILE
  IDXname.s = "Cheetah.idx"

;==========================================================================================
; Open the database (database must be open prior to creating index)
  dbHandle.l = xdbOpen(DBFName,"") ;no encryption

   ;Choose to open the LAST name index
   idxHandle.l = xdbOpenIndex(IDXname, dbHandle)

   xdbReindexAll(dbHandle, 0)
   ;This procedure actually 'builds' the index and makes each index usable.
   ; I don't think you need to do this that often, it does slow down the process.

;=============================================================================   
;Retrieve record # 12 and examine its field contents
    RecNo.l = 12
    xdbGetRecord(dbHandle, 12)
      
 ;Just to see if it found record 12
   RecNo.l = xdbRecordNumber(dbHandle)
   FieldValue.s = xdbFieldValue(dbHandle, "CUSTID", 0)
   Debug FieldValue + " - What I see at record 12"

       ;NOTE: Notice that I never asked for the record number. You
      ;      must you EITHER FieldName OR the FieldNumber
      ; NOTE#2 - THIS IS WHY I USED A ZERO FOR THE FIELDNUMBER

   xdbGetRecord(dbHandle, 13)
  res2.s = xdbFieldValue(dbHandle, "CUSTNAME", 0) 
 Debug res2 + " - What I see at record 13 and the Cust name field"


;=============================================================================
;Close the database and related index
 xdbClose(dbHandle)                                 
  
;Close any open DLL's  
xdb_End()
End
; ExecutableFormat=Windows
; CursorPosition=32
; FirstLine=3
; EnableAsm
; EnableNT4
; Executable=C:\PureBasic\BobDev\DLLs\test.exe
; EOF