; ------------------------------------------------------------
;
;   PureBasic - Cheetah.DBF tests taken from Cheetah's help file
;                     
;                       GENERAL USE FUNCTIONS
;                       ~~~~~~~~~~~~~~~~~~~~~ 
;   These do not need an open table, etc.
;   Functions taken directly from the Cheetah help CHM file.
;
; blueb@shaw.ca
; ------------------------------------------------------------


;********************************************************************************
;
; Note#1: This version of Cheetah uses the "Z" extensions (Zero delimited strings)
;         (Simply add a _Z to the commands in the help file.)
;         You may have to download the latest version of Cheetah.dll demo
;
;         (I downloaded the Cheetah Demo. - it works)
;         (I also tested with PureBasic Demo program - 3.90)
;
; Note#2 - The Cheetah API expects uppercase commands 
;          and each command returns a string or a long, hence PeekS() function
;
;********************************************************************************
; These are 
;==============================================
; Return Application's path
  Debug xdbAppPath()
;==============================================
; CheetahDate$ = CTOD(BASICdate$)
; Convert a date string to the prefered  xbase date of: YYYYMMDD
; These dates must be in the dBase form of mm-dd-yyy
  Debug xdbCToD("11-01-2003") 

  
;==============================================
; This function takes a Cheetah (xBase) date (YYYYMMDD) and converts it into a 
; standard BASIC format date (MM-DD-YYYY).
; BASICdate$ = DTOS(CheetahDate$)
  Debug xdbDToS("20031231")
  
;==============================================
; NewDate$ = xdbAddDate$(StartDate$, NumDays&) 
; NewDate$ = xdbAddDate("20021231", 5) 'Add 5 days to the date December 31, 2002
  Debug xdbAddDate("20021231", 5)

; ;==============================================
; ;JulianDate& = xdbDateToJulian&(DateString$) 
; ;This function converts a Date (in YYYYMMDD format) To a long integer. 
; ;The value is referred To as a Julian date And is very useful when performing date arithmetic. 
; ;The long integers can be added Or subtracted To determine other dates. 
   Debug xdbDateToJulian("20021231")
    
; ;==============================================
; ;NormalDate$ = xdbJulianToDate$(JulianNumber&) 
; ;This function simply converts a long integer in Julian format To a date string in YYYYMMDD format.
   Debug xdbJulianToDate(2452591)
;  
; ;==============================================
; ;NumDays& = xdbDaysApart&(DateFrom$, DateTo$) 
; ;Determine how may days separate the two dates. The dates must enter in the YYYYMMDD format.
   Debug xdbDaysApart("20031231", "20041230")
;   
; ;==============================================
; ;NumDays& = xdbDaysInMonth&(Year&, Month&)
; ;Simply determines how many days are in a given month. This function is leap-year aware, 
; ;therefore the need To specify the year. The year must be in 4-digit format (e.g. 1995, not 95).
   Debug xdbDaysInMonth(2004, 2)
 ;  
; ;==============================================
; ;TrueFalse& = xdbValidDate&(DateCheck$) 
; ;This function returns either %XDBTRUE Or %XDBFALSE depending whether the date passed 
; ; to it (in YYYYMMDD format) is valid Or not.
   Debug xdbValidDate("20041232")

; ;==============================================
; ;ProgramVersion$ = xdbVersion$
; ;This function returns the version of Cheetah
Debug xdbVersion()

End

; ExecutableFormat=Windows
; CursorPosition=59
; FirstLine=39
; EOF