; ========================================================================
;                         Cheetah - PureBasic Wrapper
;   Original Wrapper by Stefan Schnell - Additions by blueb
; LoadMemoryDLL enabled by S.Rings
; ========================================================================
Global xdbhDLL.l  ;dll handle in Memory


;pointer to raw Memory Positions
Global XDBCTOD_Z
Global XDBDTOS_Z

Global XDBACTIVATE_Z
Global XDBADDDATE_Z
Global XDBADDFIELD_Z
Global XDBALIAS_Z
Global XDBAPPENDRECORD_Z
Global XDBAPPPATH_Z
Global XDBASSIGNFIELD_Z

Global XDBASSIGNFIELDINT_Z
Global XDBASSIGNFIELDLNG_Z
Global XDBASSIGNFIELDSNG_Z
Global XDBASSIGNMEMO_Z
Global XDBBOF_Z

Global XDBOPEN_Z
Global XDBCLOSE_Z
Global XDBOPENINDEX_Z
Global XDBREINDEXALL_Z
Global XDBGETRECORD_Z
Global XDBRECORDNUMBER_Z
Global XDBFIELDVALUE_Z
Global XDBCREATE_Z
Global XDBCLOSEINDEX_Z
Global XDBCREATEINDEX_Z
Global XDBFIELDNUMBER_Z
Global XDBCLEARBUFFER_Z

Global XDBADDRECORD_Z
Global XDBERROR_Z
Global XDBRESETERROR_Z
Global XDBPUTRECORD_Z


Global XDBCLOSEALLINDEXES_Z
Global XDBCREATEEXTENDED_Z
Global XDBCREATEFIELDS_Z
Global XDBCREATEFIELDSEXTENDED_Z
Global XDBCREATEQUERY_Z
Global XDBDATABASEHANDLES_Z
Global XDBDATETOJULIAN_Z
Global XDBDAYSAPART_Z
Global XDBDAYSINMONTH_Z
Global XDB;DebugMODE_Z
Global XDBDELETED_Z
Global XDBDELETERECORD_Z
Global XDBDESTROYQUERY_Z
Global XDBENCRYPTIONMETHOD_Z
Global XDBEOF_Z
Global XDBFAILEDLOCKINFO_Z
Global XDBFIELDCOUNT_Z
Global XDBFIELDDECIMALS_Z
Global XDBFIELDINFO_Z
Global XDBFIELDLENGTH_Z
Global XDBFIELDNAME_Z
Global XDBFIELDPADDING_Z
Global XDBFIELDTYPE_Z
Global XDBFIELDVALUEINT_Z
Global XDBFIELDVALUELNG_Z
Global XDBFIELDVALUESNG_Z
Global XDBFLUSHDATABASE_Z
Global XDBHTMLSTRIPTAG_Z
Global XDBINDEXHANDLES_Z
Global XDBISEDITLOCK_Z
Global XDBISENCRYPTED_Z
Global XDBJULIANTODATE_Z
Global XDBKEYCOUNT_Z
Global XDBKEYEXPRESSION_Z
Global XDBKEYLENGTH_Z
Global XDBKEYPOSITION_Z
Global XDBKEYUNIQUE_Z
Global XDBLASTUPDATED_Z
Global XDBMEMOVALUEADDR_Z
Global XDBMEMOVALUELEN_Z
Global XDBMKI_Z
Global XDBMKL_Z
Global XDBMOVEFIRST_Z
Global XDBMOVELAST_Z
Global XDBMOVENEXT_Z
Global FXDBMOVEPREV_Z;FXDBMOVEPREV_Z
Global XDBMULTIUSER_Z
Global XDBNAMEOFDAY_Z
Global XDBOPENEX_Z
Global XDBPACK_Z
Global XDBQUERYAVG_Z
Global XDBQUERYCONDITION_Z
Global XDBQUERYDISTINCT_Z
Global XDBQUERYEXECUTE_Z
Global XDBQUERYINDEX_Z
Global XDBQUERYMAX_Z
Global XDBQUERYMIN_Z
Global XDBQUERYSORT_Z
Global XDBQUERYSUM_Z
Global XDBRECALLRECORD_Z
Global XDBRECORDBUFFER_Z
Global XDBRECORDCOUNT_Z
Global XDBREGISTEREDTO_Z
Global XDBREINDEX_Z
Global XDBREMOVEEDITLOCK_Z
Global XDBREMOVEEXCLUSIVELOCK_Z
Global XDBSEEK_Z
Global XDBSEEKNEXT_Z
Global XDBSEEKPARTIAL_Z
Global XDBSEEKPARTIALNEXT_Z
Global XDBSETALIAS_Z
Global XDBSETCALLBACK_Z
Global XDBSETEDITLOCK_Z
Global XDBSETEXCLUSIVELOCK_Z
Global XDBSKIPDELETED_Z
Global XDBSPEEDAPPEND_Z
Global XDBTEMPFILENAME_Z
Global XDBTODAYSDATE_Z
Global XDBVALIDDATE_Z
Global XDBVERSION_Z
Global XDBZAP_Z


ProcedureDLL xdb_Init() 
; Procedure to load CHEETAH2.DLL permanently 
 ;xdbhDLL = OpenLibrary(#PB_ANY, "CHEETAH2.DLL") 
 xdbhDLL = LoadLibraryM(?XDB1)
 ;Debug xdbhDLL

 XDBOPEN_Z=GetProcAddressM(xdbhDLL ,"XDBOPEN_Z")
 ;Debug XDBOPEN_Z

 XDBCLOSE_Z=GetProcAddressM(xdbhDLL ,"XDBCLOSE_Z")
 ;Debug XDBCLOSE_Z

 XDBOPENINDEX_Z = GetProcAddressM(xdbhDLL ,"XDBOPENINDEX_Z")
 ;Debug XDBOPENINDEX_Z

 XDBREINDEXALL_Z= GetProcAddressM(xdbhDLL ,"XDBREINDEXALL_Z") 
 ;Debug XDBREINDEXALL_Z
 
 XDBGETRECORD_Z=GetProcAddressM(xdbhDLL ,"XDBGETRECORD_Z")
 ;Debug XDBGETRECORD_Z

 XDBRECORDNUMBER_Z=GetProcAddressM(xdbhDLL ,"XDBRECORDNUMBER_Z")
 ;Debug XDBRECORDNUMBER_Z

 XDBFIELDVALUE_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDVALUE_Z")
 ;Debug XDBFIELDVALUE_Z

 XDBCREATE_Z=GetProcAddressM(xdbhDLL ,"XDBCREATE_Z")
 ;Debug XDBCREATE_Z

 XDBCLOSEINDEX_Z=GetProcAddressM(xdbhDLL ,"XDBCLOSEINDEX_Z")
 ;Debug XDBCLOSEINDEX_Z
 
 XDBCREATEINDEX_Z=GetProcAddressM(xdbhDLL ,"XDBCREATEINDEX_Z")
 ;Debug XDBCREATEINDEX_Z
 
 XDBFIELDNUMBER_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDNUMBER_Z")
 ;Debug XDBFIELDNUMBER_Z
 
 XDBCLEARBUFFER_Z=GetProcAddressM(xdbhDLL ,"XDBCLEARBUFFER_Z")
 ;Debug XDBCLEARBUFFER_Z


 XDBERROR_Z=GetProcAddressM(xdbhDLL ,"XDBERROR_Z")
 ;Debug XDBERROR_Z

 XDBRESETERROR_Z=GetProcAddressM(xdbhDLL ,"XDBRESETERROR_Z")
 ;Debug XDBRESETERROR_Z

 XDBPUTRECORD_Z=GetProcAddressM(xdbhDLL ,"XDBPUTRECORD_Z")
 ;Debug XDBPUTRECORD_Z

 xdbCTOD_Z=GetProcAddressM(xdbhDLL ,"CTOD_Z")
 ;Debug xdbCTOD_Z

 xdbDTOS_Z=GetProcAddressM(xdbhDLL ,"DTOS_Z")
 ;Debug xdbDTOS_Z
  
 ;Not needed anymore, dactivated
 ;XDBACTIVATE_Z=GetProcAddressM(xdbhDLL ,"XDBACTIVATE_Z")
 ;;Debug XDBACTIVATE_Z

 XDBADDDATE_Z=GetProcAddressM(xdbhDLL ,"XDBADDDATE_Z")
 ;Debug XDBADDDATE_Z

 XDBADDFIELD_Z=GetProcAddressM(xdbhDLL ,"XDBADDFIELD_Z")
 ;Debug XDBADDFIELD_Z

 XDBADDRECORD_Z=GetProcAddressM(xdbhDLL ,"XDBADDRECORD_Z")
 ;Debug XDBADDRECORD_Z

 XDBALIAS_Z=GetProcAddressM(xdbhDLL ,"XDBALIAS_Z")
 ;Debug XDBALIAS_Z

 XDBAPPENDRECORD_Z=GetProcAddressM(xdbhDLL ,"XDBAPPENDRECORD_Z")
 ;Debug XDBAPPENDRECORD_Z

 XDBAPPPATH_Z=GetProcAddressM(xdbhDLL ,"XDBAPPPATH_Z")
 ;Debug XDBAPPPATH_Z
 
 XDBASSIGNFIELD_Z=GetProcAddressM(xdbhDLL ,"XDBASSIGNFIELD_Z")
 ;Debug XDBASSIGNFIELD_Z 
 
 XDBASSIGNFIELDINT_Z=GetProcAddressM(xdbhDLL ,"XDBASSIGNFIELDINT_Z")
 ;Debug XDBASSIGNFIELDINT_Z

 XDBASSIGNFIELDLNG_Z=GetProcAddressM(xdbhDLL ,"XDBASSIGNFIELDLNG_Z")
 ;Debug XDBASSIGNFIELDLNG_Z

 XDBASSIGNFIELDSNG_Z=GetProcAddressM(xdbhDLL ,"XDBASSIGNFIELDSNG_Z")
 ;Debug XDBASSIGNFIELDSNG_Z

 XDBASSIGNMEMO_Z=GetProcAddressM(xdbhDLL ,"XDBASSIGNMEMO_Z")
 ;Debug XDBASSIGNMEMO_Z

 XDBBOF_Z=GetProcAddressM(xdbhDLL ,"XDBBOF_Z")
 ;Debug XDBBOF_Z



 XDBCLOSEALLINDEXES_Z=GetProcAddressM(xdbhDLL ,"XDBCLOSEALLINDEXES_Z")
 ;Debug XDBCLOSEALLINDEXES_Z

 XDBCREATEEXTENDED_Z=GetProcAddressM(xdbhDLL ,"XDBCREATEEXTENDED_Z")
 ;Debug XDBCREATEEXTENDED_Z

 XDBCREATEFIELDS_Z=GetProcAddressM(xdbhDLL ,"XDBCREATEFIELDS_Z")
 ;Debug XDBCREATEFIELDS_Z

 XDBCREATEFIELDSEXTENDED_Z=GetProcAddressM(xdbhDLL ,"XDBCREATEFIELDSEXTENDED_Z")
 ;Debug XDBCREATEFIELDSEXTENDED_Z

 XDBCREATEQUERY_Z=GetProcAddressM(xdbhDLL ,"XDBCREATEQUERY_Z")
 ;Debug XDBCREATEQUERY_Z

 XDBDATABASEHANDLES_Z=GetProcAddressM(xdbhDLL ,"XDBDATABASEHANDLES_Z")
 ;Debug XDBDATABASEHANDLES_Z

 XDBDATETOJULIAN_Z=GetProcAddressM(xdbhDLL ,"XDBDATETOJULIAN_Z")
 ;Debug XDBDATETOJULIAN_Z

 XDBDAYSAPART_Z=GetProcAddressM(xdbhDLL ,"XDBDAYSAPART_Z")
 ;Debug XDBDAYSAPART_Z

 XDBDAYSINMONTH_Z=GetProcAddressM(xdbhDLL ,"XDBDAYSINMONTH_Z")
 ;Debug XDBDAYSINMONTH_Z

 XDBDebugMODE_Z=GetProcAddressM(xdbhDLL ,"XDB;DebugMODE_Z")
 ;Debug XDB;DebugMODE_Z

 XDBDELETED_Z=GetProcAddressM(xdbhDLL ,"XDBDELETED_Z")
 ;Debug XDBDELETED_Z

 XDBDELETERECORD_Z=GetProcAddressM(xdbhDLL ,"XDBDELETERECORD_Z")
 ;Debug XDBDELETERECORD_Z

 XDBDESTROYQUERY_Z=GetProcAddressM(xdbhDLL ,"XDBDESTROYQUERY_Z")
 ;Debug XDBDESTROYQUERY_Z

 XDBENCRYPTIONMETHOD_Z=GetProcAddressM(xdbhDLL ,"XDBENCRYPTIONMETHOD_Z")
 ;Debug XDBENCRYPTIONMETHOD_Z

 XDBEOF_Z=GetProcAddressM(xdbhDLL ,"XDBEOF_Z")
 ;Debug XDBEOF_Z

 XDBFAILEDLOCKINFO_Z=GetProcAddressM(xdbhDLL ,"XDBFAILEDLOCKINFO_Z")
 ;Debug XDBFAILEDLOCKINFO_Z

 XDBFIELDCOUNT_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDCOUNT_Z")
 ;Debug XDBFIELDCOUNT_Z

 XDBFIELDDECIMALS_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDDECIMALS_Z")
 ;Debug XDBFIELDDECIMALS_Z

 XDBFIELDINFO_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDINFO_Z")
 ;Debug XDBFIELDINFO_Z

 XDBFIELDLENGTH_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDLENGTH_Z")
 ;Debug XDBFIELDLENGTH_Z

 XDBFIELDNAME_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDNAME_Z")
 ;Debug XDBFIELDNAME_Z

 XDBFIELDPADDING_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDPADDING_Z")
 ;Debug XDBFIELDPADDING_Z

 XDBFIELDTYPE_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDTYPE_Z")
 ;Debug XDBFIELDTYPE_Z

 XDBFIELDVALUEINT_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDVALUEINT_Z")
 ;Debug XDBFIELDVALUEINT_Z

 XDBFIELDVALUELNG_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDVALUELNG_Z")
 ;Debug XDBFIELDVALUELNG_Z

 XDBFIELDVALUESNG_Z=GetProcAddressM(xdbhDLL ,"XDBFIELDVALUESNG_Z")
 ;Debug XDBFIELDVALUESNG_Z

 XDBFLUSHDATABASE_Z=GetProcAddressM(xdbhDLL ,"XDBFLUSHDATABASE_Z")
 ;Debug XDBFLUSHDATABASE_Z

 XDBHTMLSTRIPTAG_Z=GetProcAddressM(xdbhDLL ,"XDBHTMLSTRIPTAG_Z") 
 ;Debug XDBHTMLSTRIPTAG_Z

 XDBINDEXHANDLES_Z=GetProcAddressM(xdbhDLL ,"XDBINDEXHANDLES_Z")
 ;Debug XDBINDEXHANDLES_Z

 XDBISEDITLOCK_Z=GetProcAddressM(xdbhDLL ,"XDBISEDITLOCK_Z")
 ;Debug XDBISEDITLOCK_Z

 XDBISENCRYPTED_Z=GetProcAddressM(xdbhDLL ,"XDBISENCRYPTED_Z")
 ;Debug XDBISENCRYPTED_Z

 XDBJULIANTODATE_Z=GetProcAddressM(xdbhDLL ,"XDBJULIANTODATE_Z")
 ;Debug XDBJULIANTODATE_Z

 XDBKEYCOUNT_Z=GetProcAddressM(xdbhDLL ,"XDBKEYCOUNT_Z")
 ;Debug XDBKEYCOUNT_Z

 XDBKEYEXPRESSION_Z=GetProcAddressM(xdbhDLL ,"XDBKEYEXPRESSION_Z")
 ;Debug XDBKEYEXPRESSION_Z

 XDBKEYLENGTH_Z=GetProcAddressM(xdbhDLL ,"XDBKEYLENGTH_Z")
 ;Debug XDBKEYLENGTH_Z

 XDBKEYPOSITION_Z=GetProcAddressM(xdbhDLL ,"XDBKEYPOSITION_Z")
 ;Debug XDBKEYPOSITION_Z

 XDBKEYUNIQUE_Z=GetProcAddressM(xdbhDLL ,"XDBKEYUNIQUE_Z")
 ;Debug XDBKEYUNIQUE_Z

 XDBLASTUPDATED_Z=GetProcAddressM(xdbhDLL ,"XDBLASTUPDATED_Z")
 ;Debug XDBLASTUPDATED_Z

 XDBMEMOVALUEADDR_Z=GetProcAddressM(xdbhDLL ,"XDBMEMOVALUEADDR_Z")
 ;Debug XDBMEMOVALUEADDR_Z

 XDBMEMOVALUELEN_Z=GetProcAddressM(xdbhDLL ,"XDBMEMOVALUELEN_Z")
 ;Debug XDBMEMOVALUELEN_Z

 XDBMKI_Z=GetProcAddressM(xdbhDLL ,"XDBMKI_Z")
 ;Debug XDBMKI_Z

 XDBMKL_Z=GetProcAddressM(xdbhDLL ,"XDBMKL_Z")
 ;Debug XDBMKL_Z

 XDBMOVEFIRST_Z=GetProcAddressM(xdbhDLL ,"XDBMOVEFIRST_Z")
 ;Debug XDBMOVEFIRST_Z

 XDBMOVELAST_Z=GetProcAddressM(xdbhDLL ,"XDBMOVELAST_Z")
 ;Debug XDBMOVELAST_Z

 XDBMOVENEXT_Z=GetProcAddressM(xdbhDLL ,"XDBMOVENEXT_Z")
 ;Debug XDBMOVENEXT_Z

 FXDBMOVEPREV_Z=GetProcAddressM(xdbhDLL ,"XDBMOVEPREV_Z")
 ;Debug FXDBMOVEPREV_Z

 XDBMULTIUSER_Z=GetProcAddressM(xdbhDLL ,"XDBMULTIUSER_Z")
 ;Debug XDBMULTIUSER_Z

 XDBNAMEOFDAY_Z=GetProcAddressM(xdbhDLL ,"XDBNAMEOFDAY_Z")
 ;Debug XDBNAMEOFDAY_Z

 XDBOPENEX_Z=GetProcAddressM(xdbhDLL ,"XDBOPENEX_Z")
 ;Debug XDBOPENEX_Z

 XDBPACK_Z=GetProcAddressM(xdbhDLL ,"XDBPACK_Z")
 ;Debug XDBPACK_Z

 XDBQUERYAVG_Z=GetProcAddressM(xdbhDLL ,"XDBQUERYAVG_Z")
 ;Debug XDBQUERYAVG_Z

 XDBQUERYCONDITION_Z=GetProcAddressM(xdbhDLL ,"XDBQUERYCONDITION_Z")
 ;Debug XDBQUERYCONDITION_Z

 XDBQUERYDISTINCT_Z=GetProcAddressM(xdbhDLL ,"XDBQUERYDISTINCT_Z")
 ;Debug XDBQUERYDISTINCT_Z

 XDBQUERYEXECUTE_Z=GetProcAddressM(xdbhDLL ,"XDBQUERYEXECUTE_Z")
 ;Debug XDBQUERYEXECUTE_Z

 XDBQUERYINDEX_Z=GetProcAddressM(xdbhDLL ,"XDBQUERYINDEX_Z")
 ;Debug XDBQUERYINDEX_Z

 XDBQUERYMAX_Z=GetProcAddressM(xdbhDLL ,"XDBQUERYMAX_Z")
 ;Debug XDBQUERYMAX_Z

 XDBQUERYMIN_Z=GetProcAddressM(xdbhDLL ,"XDBQUERYMIN_Z")
 ;Debug XDBQUERYMIN_Z

 XDBQUERYSORT_Z=GetProcAddressM(xdbhDLL ,"XDBQUERYSORT_Z")
 ;Debug XDBQUERYSORT_Z

 XDBQUERYSUM_Z=GetProcAddressM(xdbhDLL ,"XDBQUERYSUM_Z")
 ;Debug XDBQUERYSUM_Z

 XDBRECALLRECORD_Z=GetProcAddressM(xdbhDLL ,"XDBRECALLRECORD_Z")
 ;Debug XDBRECALLRECORD_Z

 XDBRECORDBUFFER_Z=GetProcAddressM(xdbhDLL ,"XDBRECORDBUFFER_Z")
 ;Debug XDBRECORDBUFFER_Z

 XDBRECORDCOUNT_Z=GetProcAddressM(xdbhDLL ,"XDBRECORDCOUNT_Z")
 ;Debug XDBRECORDCOUNT_Z

 XDBREGISTEREDTO_Z=GetProcAddressM(xdbhDLL ,"XDBREGISTEREDTO_Z")
 ;Debug XDBREGISTEREDTO_Z

 XDBREINDEX_Z=GetProcAddressM(xdbhDLL ,"XDBREINDEX_Z")
 ;Debug XDBREINDEX_Z

 XDBREMOVEEDITLOCK_Z=GetProcAddressM(xdbhDLL ,"XDBREMOVEEDITLOCK_Z")
 ;Debug XDBREMOVEEDITLOCK_Z

 XDBREMOVEEXCLUSIVELOCK_Z=GetProcAddressM(xdbhDLL ,"XDBREMOVEEXCLUSIVELOCK_Z")
 ;Debug XDBREMOVEEXCLUSIVELOCK_Z

 XDBSEEK_Z=GetProcAddressM(xdbhDLL ,"XDBSEEK_Z")
 ;Debug XDBSEEK_Z

 XDBSEEKNEXT_Z=GetProcAddressM(xdbhDLL ,"XDBSEEKNEXT_Z")
 ;Debug XDBSEEKNEXT_Z

 XDBSEEKPARTIAL_Z=GetProcAddressM(xdbhDLL ,"XDBSEEKPARTIAL_Z")
 ;Debug XDBSEEKPARTIAL_Z

 XDBSEEKPARTIALNEXT_Z=GetProcAddressM(xdbhDLL ,"XDBSEEKPARTIALNEXT_Z")
 ;Debug XDBSEEKPARTIALNEXT_Z

 XDBSETALIAS_Z=GetProcAddressM(xdbhDLL ,"XDBSETALIAS_Z")
 ;Debug XDBSETALIAS_Z

 XDBSETCALLBACK_Z=GetProcAddressM(xdbhDLL ,"XDBSETCALLBACK_Z")
 ;Debug XDBSETCALLBACK_Z

 XDBSETEDITLOCK_Z=GetProcAddressM(xdbhDLL ,"XDBSETEDITLOCK_Z")
 ;Debug XDBSETEDITLOCK_Z

 XDBSETEXCLUSIVELOCK_Z=GetProcAddressM(xdbhDLL ,"XDBSETEXCLUSIVELOCK_Z")
 ;Debug XDBSETEXCLUSIVELOCK_Z

 XDBSKIPDELETED_Z=GetProcAddressM(xdbhDLL ,"XDBSKIPDELETED_Z")
 ;Debug XDBSKIPDELETED_Z

 XDBSPEEDAPPEND_Z=GetProcAddressM(xdbhDLL ,"XDBSPEEDAPPEND_Z")
 ;Debug XDBSPEEDAPPEND_Z

 XDBTEMPFILENAME_Z=GetProcAddressM(xdbhDLL ,"XDBTEMPFILENAME_Z")
 ;Debug XDBTEMPFILENAME_Z

 XDBTODAYSDATE_Z=GetProcAddressM(xdbhDLL ,"XDBTODAYSDATE_Z")
 ;Debug XDBTODAYSDATE_Z

 XDBVALIDDATE_Z=GetProcAddressM(xdbhDLL ,"XDBVALIDDATE_Z")
 ;Debug XDBVALIDDATE_Z

 XDBVERSION_Z=GetProcAddressM(xdbhDLL ,"XDBVERSION_Z")
 ;Debug XDBVERSION_Z

 XDBZAP_Z=GetProcAddressM(xdbhDLL ,"XDBZAP_Z")
 ;Debug XDBZAP_Z


; -----------------
 DataSection:
  XDB1:
  IncludeBinary "Cheetah2.dll"
 EndDataSection


EndProcedure 


;  -------------------------------------------------------------------- 
ProcedureDLL xdb_End()
; Procedure to unload CHEETAH2.DLL after xdbUseDLL 
 FreeLibraryM(xdbhDLL )
 ;MessageRequester("Info","end ",0)
;CloseLibrary(xdbhDLL) 
EndProcedure 

;  ------------------------------------------------------------------ 
ProcedureDLL.s xdbCToD(BASICdate.s) 
 ProcedureReturn PeekS(CallFunctionFast(xdbCToD_Z, @BASICdate)) 
EndProcedure 

ProcedureDLL.s xdbDToS(CheetahDate.s) 
 ProcedureReturn PeekS(CallFunctionFast(xdbDTOS_Z, @CheetahDate)) 
EndProcedure 

    ;  ------------------------------------------------------------------ 

ProcedureDLL xdbActivate(RegNumber.l) 
;deactivated, not needed !
;ProcedureReturn CallFunctionFast(XDBACTIVATE_Z, RegNumber) 
EndProcedure 

    ;  ------------------------------------------------------------------ 

ProcedureDLL.s xdbAddDate(StartDate.s, NumDays.l) 
 ProcedureReturn PeekS(CallFunctionFast(XDBADDDATE_Z, @StartDate, NumDays)) 
EndProcedure 

    ;  ------------------------------------------------------------------ 

ProcedureDLL xdbAddField(FieldInfo.s) 
ProcedureReturn CallFunctionFast(XDBADDFIELD_Z, @FieldInfo) 
EndProcedure 

    ;  ------------------------------------------------------------------ 

ProcedureDLL xdbAddRecord(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBADDRECORD_Z, DBFhandle) 
EndProcedure 

    ;  ------------------------------------------------------------------ 

ProcedureDLL.s xdbAlias(DBFhandle.l) 
 ProcedureReturn PeekS(CallFunctionFast(XDBALIAS_Z, DBFhandle)) 
EndProcedure 

    ;  ------------------------------------------------------------------ 

ProcedureDLL xdbAppendRecord(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBAPPENDRECORD_Z, DBFhandle) 
EndProcedure 

    ;  ------------------------------------------------------------------ 

ProcedureDLL.s xdbAppPath() 
 ProcedureReturn PeekS(CallFunctionFast(XDBAPPPATH_Z)) 
EndProcedure 

    ;  ------------------------------------------------------------------ 

ProcedureDLL xdbAssignField(DBFhandle.l, FieldName.s, FieldNumber.l, FieldString.s) 
 ProcedureReturn CallFunctionFast(XDBASSIGNFIELD_Z, DBFhandle, @FieldName, FieldNumber, @FieldString) 
EndProcedure 


    ;  Currency: 8byte float--------------------------------------------- 
    ;   
    ;   This function does not work with PureBASIC, because PureBASIC 
    ;   supports only 4byte floating point 
    ;   
    ;  ------------------------------------------------------------------ 

      ;ProcedureDLL xdbAssignFieldCUR(DBFhandle.l, FieldName.s, FieldNumber.l, CurrencyValue.f) 
      ;  CallFunction(xdbhDLL, "XDBASSIGNFIELDCUR_Z", DBFhandle, @FieldName, FieldNumber, @CurrencyValue) 
      ;EndProcedure 

    ;  Double: 8byte float----------------------------------------------- 
    ;   
    ;   This function does not work with PureBASIC, because PureBASIC 
    ;   supports only 4byte floating point 
    ;   
    ;  ------------------------------------------------------------------ 

      ;ProcedureDLL xdbAssignFieldDBL(DBFhandle.l, FieldName.s, FieldNumber.l, DoubleValue.f) 
      ;  CallFunction(xdbhDLL, "XDBASSIGNFIELDDBL_Z", DBFhandle, @FieldName, FieldNumber, @DoubleValue) 
      ;EndProcedure 

   ;  Integer: From -32768 to +32767------------------------------------ 
ProcedureDLL xdbAssignFieldINT(DBFhandle.l, FieldName.s, FieldNumber.l, IntValue.w) 
 ProcedureReturn CallFunctionFast(XDBASSIGNFIELDINT_Z, DBFhandle, @FieldName, FieldNumber, IntValue) 
EndProcedure 

   ;  Long: From -2147483648 to +2147483647----------------------------- 
ProcedureDLL xdbAssignFieldLNG(DBFhandle.l, FieldName.s, FieldNumber.l, LongValue.l) 
 ProcedureReturn CallFunctionFast(XDBASSIGNFIELDLNG_Z, DBFhandle, @FieldName, FieldNumber, LongValue) 
EndProcedure 

   ;  Single: 4byte float----------------------------------------------- 
ProcedureDLL xdbAssignFieldSNG(DBFhandle.l, FieldName.s, FieldNumber.l, SingleValue.f) 
 ProcedureReturn  CallFunctionFast(XDBASSIGNFIELDSNG_Z, DBFhandle, @FieldName, FieldNumber, @SingleValue) 
EndProcedure 

ProcedureDLL xdbAssignMemo(DBFhandle.l, FieldName.s, FieldNumber.l, MemAddress.l, StringLength.l) 
ProcedureReturn  CallFunctionFast(XDBASSIGNMEMO_Z, DBFhandle, @FieldName, FieldNumber, MemAddress, StringLength) 
EndProcedure 

ProcedureDLL.l xdbBOF(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBBOF_Z, DBFhandle) 
EndProcedure 

    ;  ------------------------------------------------------------------ 

ProcedureDLL xdbClearBuffer(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBCLEARBUFFER_Z, DBFhandle) 
EndProcedure 

    ;  ------------------------------------------------------------------ 

ProcedureDLL xdbClose(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBCLOSE_Z, DBFhandle) 
EndProcedure 

    ;  ------------------------------------------------------------------ 

ProcedureDLL xdbCloseAllIndexes(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBCLOSEALLINDEXES_Z, DBFhandle) 
EndProcedure 

ProcedureDLL xdbCloseIndex(DBFhandle.l, idxHandle.l) 
 ProcedureReturn CallFunctionFast(XDBCLOSEINDEX_Z, DBFhandle, idxHandle) 
EndProcedure 

ProcedureDLL xdbCreate(FileName.s, FieldArray.s) 
 ProcedureReturn CallFunctionFast(XDBCREATE_Z, @FileName, @FieldArray) 
EndProcedure 

ProcedureDLL xdbCreateExtended(FileName.s, FieldArray.s, MemoBlockSize.l, Algorithm.l, EncryptionKey.s) 
 ProcedureReturn  CallFunctionFast(XDBCREATEEXTENDED_Z, @FileName, @FieldArray, MemoBlockSize, Algorithm, @EncryptionKey) 
EndProcedure 

ProcedureDLL xdbCreateFields(DBFname.s) 
 ProcedureReturn  CallFunctionFast(XDBCREATEFIELDS_Z, @DBFname) 
EndProcedure 

ProcedureDLL xdbCreateFieldsExtended(FileName.s, MemoBlockSize.l, Algorithm.l, EncryptionKey.s) 
 ProcedureReturn  CallFunctionFast(XDBCREATEFIELDSEXTENDED_Z, @FileName, MemoBlockSize, Algorithm, @EncryptionKey) 
EndProcedure 

ProcedureDLL xdbCreateIndex(IndexFileName.s, DBFhandle.l, IndexExpression.s, Duplicates.l) 
 ProcedureReturn  CallFunctionFast(XDBCREATEINDEX_Z, @IndexFileName, DBFhandle, @IndexExpression, Duplicates) 
EndProcedure 

ProcedureDLL.l xdbCreateQuery(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBCREATEQUERY_Z, DBFhandle) 
EndProcedure 

ProcedureDLL xdbDatabaseHandles(DBFileName.s, CheetahHandle.l, WindowsHandle.l) 
 ProcedureReturn CallFunctionFast(XDBDATABASEHANDLES_Z, @DBFileName, CheetahHandle, WindowsHandle) 
EndProcedure 

ProcedureDLL.l xdbDateToJulian(DateString.s) 
 ProcedureReturn CallFunctionFast(XDBDATETOJULIAN_Z, @DateString) 
EndProcedure 

ProcedureDLL.l xdbDaysApart(DateFrom.s, DateTo.s) 
 ProcedureReturn CallFunctionFast(XDBDAYSAPART_Z, @DateFrom, @DateTo) 
EndProcedure 

ProcedureDLL.l xdbDaysInMonth(Year.l, Month.l) 
 ProcedureReturn CallFunctionFast(XDBDAYSINMONTH_Z, Year, Month) 
EndProcedure 

ProcedureDLL xdbDebugMode(TrueFalse.l) 
 ProcedureReturn CallFunctionFast(XDBDebugMODE_Z, TrueFalse) 
EndProcedure 

ProcedureDLL.l xdbDeleted(DBFhandle.l, RecordNumber.l) 
 ProcedureReturn CallFunctionFast(XDBDELETED_Z, DBFhandle, RecordNumber) 
EndProcedure 

ProcedureDLL xdbDeleteRecord(DBFhandle.l, RecordNumber.l) 
 ProcedureReturn CallFunctionFast(XDBDELETERECORD_Z, DBFhandle, RecordNumber) 
EndProcedure 

ProcedureDLL xdbDestroyQuery(QueryHandle.l) 
 ProcedureReturn CallFunctionFast(XDBDESTROYQUERY_Z, QueryHandle) 
EndProcedure 

ProcedureDLL.l xdbEncryptionMethod(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBENCRYPTIONMETHOD_Z, DBFhandle) 
EndProcedure 

ProcedureDLL.l xdbEOF(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBEOF_Z, DBFhandle) 
EndProcedure 

ProcedureDLL xdbError() 
 ProcedureReturn CallFunctionFast(XDBERROR_Z) 
EndProcedure 

ProcedureDLL xdbFailedLockInfo(DBFhandle.l, Reason.s, Username.s, Workstation.s, LockDate.s, LockTime.s) 
  ProcedureReturn CallFunctionFast(XDBFAILEDLOCKINFO_Z, DBFhandle, @Reason, @Username, @Workstation, @LockDate, @LockTime) 
EndProcedure 

ProcedureDLL.l xdbFieldCount(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBFIELDCOUNT_Z, DBFhandle) 
EndProcedure 

ProcedureDLL xdbFieldDecimals(DBFhandle.l, FieldNumber.l, FieldName.s, FieldType.s, FieldLength.l, FieldDecimals.l) 
 ProcedureReturn CallFunctionFast(XDBFIELDDECIMALS_Z, DBFhandle, FieldNumber, @FieldName, @FieldType, FieldLength, FieldDecimals) 
EndProcedure 

ProcedureDLL xdbFieldInfo(DBFhandle.l, FieldNumber.l, FieldName.s, FieldType.s, FieldLength.l, FieldDecimals.l) 
ProcedureReturn CallFunctionFast(XDBFIELDINFO_Z, DBFhandle, FieldNumber, @FieldName, @FieldType, FieldLength, FieldDecimals) 
EndProcedure 

ProcedureDLL.l xdbFieldLength(DBFhandle.l, FieldNumber.l) 
 ProcedureReturn CallFunctionFast(XDBFIELDLENGTH_Z, DBFhandle, FieldNumber) 
EndProcedure 

ProcedureDLL.s xdbFieldName(DBFhandle.l, FieldNumber.l) 
ProcedureReturn PeekS(CallFunctionFast(XDBFIELDNAME_Z, DBFhandle, FieldNumber)) 
EndProcedure 

ProcedureDLL.l xdbFieldNumber(DBFhandle.l, FieldName.s) 
 ProcedureReturn CallFunctionFast(XDBFIELDNUMBER_Z, DBFhandle, @FieldName) 
EndProcedure 


ProcedureDLL xdbFieldPadding(DBFhandle.l, TrueFalse.l) 
 ProcedureReturn CallFunctionFast(XDBFIELDPADDING_Z, DBFhandle, TrueFalse) 
EndProcedure 

ProcedureDLL.s xdbFieldType(DBFhandle.l, FieldNumber.l) 
 ProcedureReturn PeekS(CallFunctionFast(XDBFIELDTYPE_Z, DBFhandle, FieldNumber)) 
EndProcedure 

ProcedureDLL.s xdbFieldValue(DBFhandle.l, FieldName.s, FieldNumber.l) 
 ProcedureReturn PeekS(CallFunctionFast(XDBFIELDVALUE_Z, DBFhandle, @FieldName, FieldNumber)) 
EndProcedure 


    ;  Currency: 8byte float--------------------------------------------- 
    ;   
    ;   This function does not work with PureBASIC, because PureBASIC 
    ;   supports only 4byte floating point 
    ;   
    ;  ------------------------------------------------------------------ 

      ;ProcedureDLL.f xdbFieldValueCUR(DBFhandle.l, FieldName.s, FieldNumber.l) 
      ;  ProcedureReturn CallFunction(xdbhDLL, "XDBFIELDVALUECUR_Z", DBFhandle, @FieldName, FieldNumber) 
      ;EndProcedure 

    ;  Double: 8byte float----------------------------------------------- 
    ;   
    ;   This function does not work with PureBASIC, because PureBASIC 
    ;   supports only 4byte floating point 
    ;   
    ;  ------------------------------------------------------------------ 

      ;ProcedureDLL.f xdbFieldValueDBL(DBFhandle.l, FieldName.s, FieldNumber.l) 
      ;  ProcedureReturn CallFunction(xdbhDLL, "XDBFIELDVALUEDBL_Z", DBFhandle, @FieldName, FieldNumber) 
      ;EndProcedure 

    ;  Integer: From -32768 to +32767------------------------------------ 
ProcedureDLL.w xdbFieldValueINT(DBFhandle.l, FieldName.s, FieldNumber.l) 
 ProcedureReturn CallFunctionFast(XDBFIELDVALUEINT_Z, DBFhandle, @FieldName, FieldNumber) 
EndProcedure 

    ;  Long: From -2147483648 to +2147483647----------------------------- 
ProcedureDLL.l xdbFieldValueLNG(DBFhandle.l, FieldName.s, FieldNumber.l) 
 ProcedureReturn CallFunctionFast(XDBFIELDVALUELNG_Z, DBFhandle, @FieldName, FieldNumber) 
EndProcedure 

    ;  Single: 4byte float----------------------------------------------- 
ProcedureDLL.f xdbFieldValueSNG(DBFhandle.l, FieldName.s, FieldNumber.l) 
 ProcedureReturn CallFunctionFast(XDBFIELDVALUESNG_Z, DBFhandle, @FieldName, FieldNumber) 
EndProcedure 

ProcedureDLL xdbFlushDatabase(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBFLUSHDATABASE_Z, DBFhandle) 
EndProcedure 

ProcedureDLL xdbGetRecord(DBFhandle.l, RecordNumber.l) 
 ProcedureReturn CallFunctionFast(XDBGETRECORD_Z, DBFhandle, RecordNumber) 
EndProcedure 

ProcedureDLL xdbHtmlStripTag(QueryHandle.l, TrueFalse.l) 
 ProcedureReturn CallFunctionfast(XDBHTMLSTRIPTAG_Z, QueryHandle, TrueFalse) 
EndProcedure 


ProcedureDLL xdbIndexHandles(IndexFileName.s, CheetahHandle.l, WindowsHandle.l) 
  ProcedureReturn CallFunctionFast(XDBINDEXHANDLES_Z, @IndexFileName, CheetahHandle, WindowsHandle) 
EndProcedure 

ProcedureDLL.l xdbIsEditLock(DBFhandle.l, RecordNumber.l) 
 ProcedureReturn CallFunctionFast(XDBISEDITLOCK_Z, DBFhandle, RecordNumber) 
EndProcedure 

ProcedureDLL.l xdbIsEncrypted(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBISENCRYPTED_Z, DBFhandle) 
EndProcedure 

ProcedureDLL.s xdbJulianToDate(JulianNumber.l) 
 ProcedureReturn PeekS(CallFunctionFast(XDBJULIANTODATE_Z, JulianNumber)) 
EndProcedure 

ProcedureDLL.l xdbKeyCount(DBFhandle.l, idxHandle.l) 
 ProcedureReturn CallFunctionFast(XDBKEYCOUNT_Z, DBFhandle, idxHandle) 
EndProcedure 

ProcedureDLL.s xdbKeyExpression(DBFhandle.l, idxHandle.l) 
 ProcedureReturn PeekS(CallFunctionFast(XDBKEYEXPRESSION_Z, DBFhandle, idxHandle)) 
EndProcedure 

ProcedureDLL.l xdbKeyLength(DBFhandle.l, idxHandle.l) 
 ProcedureReturn CallFunctionFast(XDBKEYLENGTH_Z, DBFhandle, idxHandle) 
EndProcedure 

ProcedureDLL.l xdbKeyPosition(idxHandle.l, KeyPosition.l) 
 ProcedureReturn CallFunctionFast(XDBKEYPOSITION_Z, idxHandle, KeyPosition) 
EndProcedure 

ProcedureDLL.l xdbKeyUnique(DBFhandle.l, idxHandle.l) 
 ProcedureReturn CallFunctionFast(XDBKEYUNIQUE_Z, DBFhandle, idxHandle) 
EndProcedure 

ProcedureDLL xdbLastUpdated(DBFhandle.l, YearNr.l, MonthNr.l, DayNr.l) 
 ProcedureReturn  CallFunctionfast(XDBLASTUPDATED_Z, YearNr, MonthNr, DayNr) 
EndProcedure 

ProcedureDLL.l xdbMemoValueAddr(DBFhandle.l, FieldName.s, FieldCode.l) 
 ProcedureReturn CallFunctionFast(XDBMEMOVALUEADDR_Z, DBFhandle, @FieldName, FieldCode) 
EndProcedure 

ProcedureDLL.l xdbMemoValueLen(DBFhandle.l, FieldName.s, FieldCode.l) 
 ProcedureReturn CallFunctionFast(XDBMEMOVALUELEN_Z, DBFhandle, @FieldName, FieldCode) 
EndProcedure 

ProcedureDLL.s xdbMKI(IntValue.w) 
 ProcedureReturn PeekS(CallFunctionFast(XDBMKI_Z, IntValue)) 
EndProcedure 

ProcedureDLL.s xdbMKL(LongValue.l) 
 ProcedureReturn PeekS(CallFunctionFast(XDBMKL_Z, LongValue)) 
EndProcedure 

ProcedureDLL xdbMoveFirst(DBFhandle.l, idxHandle.l) 
 ProcedureReturn CallFunctionFast(XDBMOVEFIRST_Z, DBFhandle, idxHandle) 
EndProcedure 

ProcedureDLL xdbMoveLast(DBFhandle.l, idxHandle.l) 
 ProcedureReturn CallFunctionFast(XDBMOVELAST_Z, DBFhandle, idxHandle) 
EndProcedure 

ProcedureDLL xdbMoveNext(DBFhandle.l, idxHandle.l) 
 ProcedureReturn CallFunctionFast(XDBMOVENEXT_Z, DBFhandle, idxHandle) 
EndProcedure 

ProcedureDLL xdbMovePrev(DBFhandle.l, idxHandle.l) 
 ProcedureReturn CallFunctionFast(FXDBMOVEPREV_Z, DBFhandle, idxHandle) 
EndProcedure 

ProcedureDLL xdbMultiUser(TrueFalse.l, NumRetries.l, WaitTimes.l) 
 ProcedureReturn CallFunctionFast(XDBMULTIUSER_Z, TrueFalse, NumRetries, WaitTimes) 
EndProcedure 

ProcedureDLL.s xdbNameOfDay(DateCheck.s) 
 ProcedureReturn PeekS(CallFunctionFast(XDBNAMEOFDAY_Z, @DateCheck)) 
EndProcedure 

ProcedureDLL.l xdbOpen(FileName.s, EncryptionKey.s) 
  ProcedureReturn CallFunctionFast(XDBOPEN_Z, @FileName, @EncryptionKey) 
EndProcedure 

ProcedureDLL.l xdbOpenEx(FileName.s, AccessMode.l, ShareMode.l, EncryptionKey.s) 
 ProcedureReturn CallFunctionFast(XDBOPENEX_Z, @FileName, AccessMode, ShareMode, @EncryptionKey) 
EndProcedure 

ProcedureDLL.l xdbOpenIndex(IndexFilename.s, DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBOPENINDEX_Z, @IndexFilename, DBFhandle) 
EndProcedure 

ProcedureDLL xdbPack(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBPACK_Z, DBFhandle) 
EndProcedure 

ProcedureDLL xdbPutRecord(DBFhandle.l, RecordNumber.l) 
 ProcedureReturn CallFunctionFast(XDBPUTRECORD_Z, DBFhandle, @RecordNumber) 
EndProcedure 

ProcedureDLL.l xdbQueryAVG(QueryHandle.l, FieldName.s) 
 ProcedureReturn CallFunctionFast(XDBQUERYAVG_Z, QueryHandle, @FieldName) 
EndProcedure 

ProcedureDLL xdbQueryCondition(QueryHandle.l, JoinPhrases.l, FieldName.s, Equality.l, vParameter1.s, vParameter2.s) 
 ProcedureReturn CallFunctionFast(XDBQUERYCONDITION_Z, QueryHandle, JoinPhrases, @FieldName, Equality, @vParameter1, @vParameter2) 
EndProcedure 

ProcedureDLL xdbQueryDistinct(QueryHandle.l, FieldName.s) 
 ProcedureReturn CallFunctionFast(XDBQUERYDISTINCT_Z, QueryHandle, @FieldName) 
EndProcedure 

ProcedureDLL xdbQueryExecute(QueryHandle.l) 
 ProcedureReturn CallFunctionFast(XDBQUERYEXECUTE_Z, QueryHandle) 
EndProcedure 

ProcedureDLL xdbQueryIndex(QueryHandle.l) 
 ProcedureReturn CallFunctionFast(XDBQUERYINDEX_Z, QueryHandle) 
EndProcedure 

ProcedureDLL.l xdbQueryMAX(QueryHandle.l, FieldName.s) 
 ProcedureReturn CallFunctionFast(XDBQUERYMAX_Z, QueryHandle, @FieldName) 
EndProcedure 

ProcedureDLL.l xdbQueryMIN(QueryHandle.l, FieldName.s) 
 ProcedureReturn CallFunctionFast(XDBQUERYMIN_Z, QueryHandle, @FieldName) 
EndProcedure 


ProcedureDLL xdbQuerySort(QueryHandle.l, FieldName.s, SortDirection.l) 
 ProcedureReturn  CallFunctionFast(XDBQUERYSORT_Z, QueryHandle, @FieldName, SortDirection) 
EndProcedure 

ProcedureDLL.l xdbQuerySUM(QueryHandle.l, FieldName.s) 
 ProcedureReturn CallFunctionFast(XDBQUERYSUM_Z, QueryHandle, @FieldName) 
EndProcedure 

ProcedureDLL xdbRecallRecord(DBFhandle.l, RecordNumber.l) 
 ProcedureReturn CallFunctionFast(XDBRECALLRECORD_Z, DBFhandle, RecordNumber) 
EndProcedure 

ProcedureDLL.s xdbRecordBuffer(DBFhandle.l) 
 ProcedureReturn PeekS(CallFunctionFast(XDBRECORDBUFFER_Z, DBFhandle)) 
EndProcedure 

ProcedureDLL.l xdbRecordCount(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBRECORDCOUNT_Z, DBFhandle) 
EndProcedure 

ProcedureDLL.l xdbRecordNumber(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBRECORDNUMBER_Z, DBFhandle) 
EndProcedure 

ProcedureDLL.s xdbRegisteredTo() 
 ProcedureReturn PeekS(CallFunctionFast(XDBREGISTEREDTO_Z)) 
EndProcedure 

ProcedureDLL xdbReindex(DBFhandle.l, idxHandle.l, UniqueContinueOrError.l) 
 ProcedureReturn CallFunctionFast(XDBREINDEX_Z, DBFhandle, idxHandle, UniqueContinueOrError) 
EndProcedure 

ProcedureDLL xdbReindexAll(DBFhandle.l, UniqueContinueOrError.l) 
ProcedureReturn CallFunctionFast(XDBREINDEXALL_Z, DBFhandle, UniqueContinueOrError) 
EndProcedure 

ProcedureDLL xdbRemoveEditLock(DBFhandle.l, Lock_Num.l) 
 ProcedureReturn CallFunctionFast(XDBREMOVEEDITLOCK_Z, DBFhandle, Lock_Num) 
EndProcedure 

ProcedureDLL xdbRemoveExclusiveLock(DBFhandle.l, Lock_Num.l) 
  ProcedureReturn CallFunctionFast(XDBREMOVEEXCLUSIVELOCK_Z, DBFhandle, Lock_Num) 
EndProcedure 

ProcedureDLL xdbResetError() 
 ProcedureReturn CallFunctionFast(XDBRESETERROR_Z) 
EndProcedure 

ProcedureDLL.l xdbSeek(DBFhandle.l, idxHandle.l, KeyToLookFor.s) 
 ProcedureReturn CallFunctionFast(XDBSEEK_Z, DBFhandle, idxHandle, @KeyToLookFor) 
EndProcedure 

ProcedureDLL.l xdbSeekNext(DBFhandle.l, idxHandle.l, KeyToLookFor.s) 
 ProcedureReturn CallFunctionFast(XDBSEEKNEXT_Z, DBFhandle, idxHandle, @KeyToLookFor) 
EndProcedure 

ProcedureDLL.l xdbSeekPartial(DBFhandle.l, idxHandle.l, PartialKeyToLookFor.s) 
 ProcedureReturn CallFunctionFast(XDBSEEKPARTIAL_Z, DBFhandle, idxHandle, @PartialKeyToLookFor) 
EndProcedure 

ProcedureDLL.l xdbSeekPartialNext(DBFhandle.l, idxHandle.l, PartialKeyToLookFor.s) 
 ProcedureReturn CallFunctionFast(XDBSEEKPARTIALNEXT_Z, DBFhandle, idxHandle, @PartialKeyToLookFor) 
EndProcedure 

ProcedureDLL xdbSetAlias(DBFhandle.l, NewAliasName.s) 
 ProcedureReturn CallFunctionFast(XDBSETALIAS_Z, DBFhandle, @NewAliasName) 
EndProcedure 

ProcedureDLL xdbSetCallBack(hWnd.l) 
 ProcedureReturn CallFunctionFast(XDBSETCALLBACK_Z, hWnd) 
EndProcedure 

ProcedureDLL.l xdbSetEditLock(DBFhandle.l, RecordNumber.l) 
 ProcedureReturn CallFunctionFast(XDBSETEDITLOCK_Z, DBFhandle, RecordNumber) 
EndProcedure 

ProcedureDLL xdbSetExclusiveLock(DBFhandle.l) 
 ProcedureReturn CallFunctionFast(XDBSETEXCLUSIVELOCK_Z, DBFhandle) 
EndProcedure 

ProcedureDLL xdbSkipDeleted(DBFhandle.l, OnOff.l) 
 ProcedureReturn CallFunctionFast(XDBSKIPDELETED_Z, DBFhandle, OnOff) 
EndProcedure 
ProcedureDLL xdbSpeedAppend(DBFhandle.l, OnOff.l) 
 ProcedureReturn CallFunctionFast(XDBSPEEDAPPEND_Z, DBFhandle, OnOff) 
EndProcedure 
ProcedureDLL xdbTempFileName() 
 ProcedureReturn PeekS(CallFunctionFast(XDBTEMPFILENAME_Z)) 
EndProcedure 

ProcedureDLL.s xdbTodaysDate() 
 ProcedureReturn PeekS(CallFunctionFast(XDBTODAYSDATE_Z)) 
EndProcedure 

ProcedureDLL.l xdbValidDate(DateCheck.s) 
 ProcedureReturn CallFunctionFast(XDBVALIDDATE_Z, @DateCheck) 
EndProcedure 

ProcedureDLL.s xdbVersion() 
 ProcedureReturn PeekS(CallFunctionFast(XDBVERSION_Z)) 
EndProcedure 

ProcedureDLL xdbZap(DBFhandle.l) 
  ProcedureReturn CallFunctionFast(XDBZAP_Z, DBFhandle) 
EndProcedure 

ProcedureDLL.s xdbAnyErrors()
; Returns the error number
  ErrorReturn = xdbError()
   If ErrorReturn
     
      Select ErrorReturn
            Case 4000
               ErrorAns.s = "FILE ACCESS ERROR"
            Case 4001
               ErrorAns.s = "INVALID DATE FORMAT"
            Case 4002
               ErrorAns.s = "FILE READ ONLY"
            Case 4003
               ErrorAns.s = "FILE WRITE ONLY"
            Case 4004
               ErrorAns.s = "INVALID FILENAME"
            Case 5000
               ErrorAns.s = "ENGINE NOT INITIALIZED"
            Case 5001
               ErrorAns.s = "FILE NOT FOUND"
            Case 5002
               ErrorAns.s = "TOO MANY FILES OPEN"
            Case 5003
               ErrorAns.s = "INVALID STRUCTURE"
            Case 5004
               ErrorAns.s = "FILE NOT OPEN"
            Case 5005
               ErrorAns.s = "RECORD OUT OF RANGE"
            Case 5006
               ErrorAns.s = "FIELD NOT FOUND"
            Case 5007
               ErrorAns.s = "INVALID FILE HANDLE"
            Case 5008
               ErrorAns.s = "INVALID FIELD LENGTH"
            Case 5009
               ErrorAns.s = "DUPLICATE ALIAS NAME"
            Case 5010
               ErrorAns.s = "INVALID ACCESSMODE"
            Case 5011
               ErrorAns.s = "INVALID SHAREMODE"
            Case 5012
               ErrorAns.s = "RECORD BUSY"
            Case 5013
               ErrorAns.s = "INCOMPATIBLE MEMO FIELDS"
            Case 5014
               ErrorAns.s = "RECORDSIZE EXCEEDED"
            Case 5015
               ErrorAns.s = "INVALID ENCRYPTIONKEY"
            Case 7000
               ErrorAns.s = "DATABASE NOT OPEN"
            Case 7002
               ErrorAns.s = "TOO MANY INDEXES OPEN"
            Case 7003
               ErrorAns.s = "INVALID KEY EXPRESSION"
            Case 7004
               ErrorAns.s = "INDEX NOT OPEN"
            Case 7005
               ErrorAns.s = "INDEX UNIQUE KEYS ONLY"            
            Case 7006
               ErrorAns.s = "SEEK NO INDEX_SET"
            Case 7007
               ErrorAns.s = "INDEX NOT FOUND"
            Case 9000
               ErrorAns.s = "QUERY NOT GENERATED"
            Case 9001
               ErrorAns.s = "QUERY INVALID FIELDNAME"
            Case 9002
               ErrorAns.s = "QUERY INVALID COMPARISON"
            Case 9003
               ErrorAns.s = "QUERY MISSING DELIMITERS"
            Case 9004
               ErrorAns.s = "QUERY MISSING SEARCHSTRING"
            Case 9005
               ErrorAns.s = "QUERY TOO MANY EXPRESSIONS"
            Case 9006
               ErrorAns.s = "QUERY EXPECTED NUMERIC STRING"
            Case 9007
               ErrorAns.s = "QUERY ERROR GETRECORD"
            Case 9008
               ErrorAns.s = "QUERY INVALID HANDLE"
            Case 9009
               ErrorAns.s = "QUERY INVALID JOINPHRASE"
            Case 9010
               ErrorAns.s = "QUERY NO WILDCARD FOUND"
            Case 9011
               ErrorAns.s = "QUERY INVALID PARENTHESIS"
            Case 99999
               ErrorAns.s = "DLL has expired (unregistered users)"
            Default
               ErrorAns.s = "Error: " + Str(ErrorReturn) + " Cheetah DLL Error...Cheetah Help file has an error list."
      EndSelect
     
     xdbResetError()
     ProcedureReturn ErrorAns
   EndIf
EndProcedure

; ExecutableFormat=
; CursorPosition=657
; FirstLine=510
; EOF