
;-Window Constants
Enumeration 1
  #Window_frmMain
EndEnumeration
#WindowIndex=#PB_Compiler_EnumerationValue

;-Gadget Constants
Enumeration 1
  ;Window_frmMain
  #Gadget_frmMain_txtPLZ
  #Gadget_frmMain_lblPLZ
  #Gadget_frmMain_lblBL
  #Gadget_frmMain_txtBL
  #Gadget_frmMain_btnOK
  #Gadget_frmMain_btnCANCEL
EndEnumeration
#GadgetIndex=#PB_Compiler_EnumerationValue

Procedure.l Window_frmMain()
  If OpenWindow(#Window_frmMain,231,185,396,71,#PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_Invisible,"PLZ-Bundesland")
    AddKeyboardShortcut(#Window_frmMain, #PB_Shortcut_Return, 0)
    If CreateGadgetList(WindowID(#Window_frmMain))
      StringGadget(#Gadget_frmMain_txtPLZ,70,5,50,20,"",#PB_String_Numeric|#PB_Text_Right)
        SendMessage_(GadgetID(#Gadget_frmMain_txtPLZ),#EM_LIMITTEXT,5,0)
        SetGadgetFont(#Gadget_frmMain_txtPLZ,LoadFont(#Gadget_frmMain_txtPLZ,"Courier New",10,0))
      TextGadget(#Gadget_frmMain_lblPLZ,5,8,60,15,"Postleitzahl:")
      TextGadget(#Gadget_frmMain_lblBL,135,8,65,15,"Bundesland:")
      StringGadget(#Gadget_frmMain_txtBL,205,5,185,20,"",#PB_String_ReadOnly)
        SetGadgetFont(#Gadget_frmMain_txtBL,LoadFont(#Gadget_frmMain_txtBL,"Courier New",10,0))
      ButtonGadget(#Gadget_frmMain_btnOK,100,40,80,20,"Ok")
      ButtonGadget(#Gadget_frmMain_btnCANCEL,205,40,80,20,"Abbrechen")
      HideWindow(#Window_frmMain,0)
      ProcedureReturn WindowID()
    EndIf
  EndIf
EndProcedure

Structure bundesl
  bl.b[2]
  Name.b[25]
EndStructure

Structure plzbl
  PLZ.b[5]
  bl.b[2]
EndStructure

bundesl.IRFile = New_RFile()
plzbl.IRFile   = New_RFile()
If bundesl = #False Or plzbl = #False
  MessageRequester("PLZ_Bundesland ERROR", "Datenbank Objekt konnte nicht erstellt werden")
  End
EndIf

If bundesl\Open("bundesl.dat") = #False Or plzbl\Open("plzbl.dat") = #False
  MessageRequester("PLZ_Bundesland ERROR", "Daten konnten nicht geffnet werden")
  bundesl\Close()
  plzbl\Close()
  End
EndIf

Bundesland.bundesl
Postleitzahl.plzbl

;-Main Loop
If Window_frmMain()
  ActivateGadget(#Gadget_frmMain_txtPLZ)
  quitfrmMain=0
  Repeat
    EventID=WaitWindowEvent()
    Select EventID
      Case #PB_Event_CloseWindow
        If EventWindowID()=#Window_frmMain
          quitfrmMain=1
        EndIf
      Case #PB_Event_Menu
        If EventMenuID() = 0
          Gosub Suchen
        EndIf
      Case #PB_Event_Gadget
        Select EventGadgetID()
          Case #Gadget_frmMain_btnOK
            Gosub Suchen
          Case #Gadget_frmMain_btnCANCEL
            quitfrmMain=1
        EndSelect
    EndSelect
  Until quitfrmMain
  CloseWindow(#Window_frmMain)
  bundesl\Close()
  plzbl\Close()
EndIf
End

Suchen:
; Anzeige formatieren
SetGadgetText(#Gadget_frmMain_txtPLZ, RSet(GetGadgetText(#Gadget_frmMain_txtPLZ), 5, "0"))
SetGadgetText(#Gadget_frmMain_txtBL, "")
While WindowEvent() : Wend
; PLZ suchen
For I = 0 To plzbl\RecCount()
  plzbl\Get(I, @Postleitzahl)
  If PeekS(@Postleitzahl\PLZ[0], 5) = GetGadgetText(#Gadget_frmMain_txtPLZ)
    For J = 0 To bundesl\RecCount() ; Ort suchen
      bundesl\Get(J, @Bundesland)
      If PeekS(@Bundesland\bl[0], 2) = PeekS(@Postleitzahl\bl[0], 2)
        SetGadgetText(#Gadget_frmMain_txtBL, PeekS(@Bundesland\Name[0], 25))
        Break 2
      EndIf
    Next
  EndIf
Next
Return
