CompilerIf #PB_Compiler_OS <> #PB_OS_Windows
  ; only for linux (MacOS ?)
  XIncludeFile "include/RFile.pbi"
CompilerEndIf

; Structur of data in RFile
Structure URLS
  Name.b[40]
  URL.b[50]
EndStructure

Global File.IRFile

Procedure Append(Name.s, URL.s)
  Adr.URLS
  PokeS(@Adr\Name[0], Left(Name, 40))
  PokeS(@Adr\URL[0], Left(URL, 50))
  File\Append(@Adr)
EndProcedure

; create Object
File.IRFile = New_RFile()
If File
  If File\Open("adress.dat") = #False; if you run the example again, it's added 2 records
    File\Create("adress.dat", SizeOf(URLS)); new randomfile
  EndIf
  Append("TS-Soft", "http://purebasic.ts-soft-online.de")
  Append("PureBasic", "http://www.purebasic.com")
  MessageRequester(File\VersionStr(), "adress.dat with: " + Str(File\RecCount() + 1) + " records created")
  File\Close()
Else
  MessageRequester("ERROR", "can't create RFile-Object")
EndIf

; IDE Options = PureBasic v3.94 (Windows - x86)
; EnableXP
; HideErrorLog