
;- BIGNUMBERS
;  Routines for
;  BIGNUMBERADD
; BigNumberSub
; BigNumberMult
; BigNumbverDiv
; BIgNumberMOD
; BIgNumberGDIV
; BigNumbers (In Stringformat)
;(C)2002 by Siegfried Rings (CODEGURU)
xp.point

#WIN=1
#Linux=2
#OS=#WIN;Linux


#WindowWidth  = 590
#WindowHeight = 180
#Nummer1=1
#Nummer2=2
#Add=3
;#Sub=4
#Multi=5
#Div=6
#NRResult=7
#Precision=8
#POW=9
#MOD=10
#GDIV=11
#Running=12
#Abort=13
#SQR=14
#SQX=15
#Dummy=16
#Time=17
Global NF1.s
Global NF2.s
Global Abort

;-OpenWindow
hwnd=OpenWindow(0, 100, 120, #WindowWidth, #WindowHeight, #PB_Window_MinimizeGadget, "BigNumbers Demonstration By Siegfried Rings")
If Hwnd
  If CreateGadgetList(WindowID())
    CompilerIf #OS = #Win ;Linux
    LoadFont (0, "Courier", 10)
    SetGadgetFont(#PB_Default,0)
    StringGadget(#Nummer1,  2, 1, 580, 25, "123458435.754",#ES_MULTILINE|#PB_Text_Right)
    StringGadget(#Nummer2,  2, 30, 580, 25, "789.2",#ES_MULTILINE|#PB_Text_Right)
    StringGadget(#NRResult,  2, 130, 580, 45, "",#ES_MULTILINE|#PB_Text_Right)
    CompilerEndIf
    CompilerIf #OS = #Linux
    StringGadget(#Nummer1,  2, 1, 580, 25, "123458435.754",0)
    StringGadget(#Nummer2,  2, 30, 580, 25, "789.2",0)
    StringGadget(#NRResult,  2, 130, 580, 45, "",0)
    CompilerEndIf
    ButtonGadget(#Add,2,60,25,25,"+")
    ButtonGadget(#SUB,30,60,25,25,"-")
    ButtonGadget(#Multi,60,60,25,25,"*")
    ButtonGadget(#Div,90,60,25,25,"/")
    ButtonGadget(#POW,120,60,25,25,"^")
    
    ButtonGadget(#MOD,2,90,35,25,"MOD")
    ButtonGadget(#GDIV,40,90,25,25,"\")
    ButtonGadget(#SQR,70,90,35,25,"SQR")
    ButtonGadget(#SQX,110,90,35,25,"SQX")
    
    
    TextGadget(#Dummy,480,60,60,20,"Precision",0)
    TextGadget(#Time,240,60,160,25,"Time needed:")
    StringGadget(#Precision, 540, 60, 42, 20, "3",0)
    
    
  EndIf
  CompilerIf #OS = #Win
  cur1 = LoadCursor_(0, #IDC_WAIT)
  CompilerEndIf
  ;- Info about
  MessageRequester("Info","This is absolutly Beta.     Some Functions (SQR and SQX )are in progress"+Chr(13)+"others are not speeded up (MOD and \)"+Chr(13)+"    :)   by Siegfried Rings",0)
  Repeat
    EventID = WaitWindowEvent()
    If EventID = #PB_EventGadget
      GadgetID=EventGadgetID()
      If GadgetID=#Add Or GadgetID=#SUB Or GadgetID=#Multi Or GadgetID=#Div Or GadgetID=#POW  Or GadgetID=#MOD Or GadgetID=#GDIV Or GadgetID=#SQR Or GadgetID=#SQX
        NR1.s=GetGadgetText(#Nummer1)
        NR2.s=GetGadgetText(#Nummer2)
        ;- Eventhandler
        If ValidNumber(NR1.s) And ValidNumber(NR2.s)
          CompilerIf #OS = #Win
          Result=SetClassLong_(Hwnd,#GCL_HCURSOR,#IDC_WAIT)
          SetCursor_(cur1)
          GTL=GetTickCount_()
          CompilerEndIf
          
          PRES.l=Val(GetGadgetText(#Precision))
          Select GadgetID
          Case #Add
            NR3.s=BIGNUMADD(NR1.s,NR2.s)
          Case #SUB
            NR3.s=BIGNUMSUB(NR1.s,NR2.s)
          Case #Multi
            NR3.s=BIGNUMMULTI(NR1.s,NR2.s)
          Case #DIV
            NR3.s=BIGNUMDIV(NR1.s,NR2.s,PRES.l)
          Case #POW
            NR2.s=BigNUMIntegerPart(NR2.s)
            NR3.s=BIGNUMPOW(NR1.s,NR2.s)
          Case #MOD
        ;    Nr3.s=BINUMMOD(NR1.s,NR2.s)
          Case #GDIV
;            Nr3.s=  BINUMGDIV(NR1.s,NR2.s)
          Case #SQR
            NR3.s= BIGNUMSQR(NR1.s,NR2.s,PRES.l)
          Case #SQX
            NR3.s= BIGNUMSQX(NR1.s,NR2.s,PRES.l)
          EndSelect
          SetGadgetText(#NRResult,NR3.s)
          CompilerIf #OS = #Win
          SetGadgetText(#Time,"Time neded:"+StrU(GetTickCount_()-GTL,2)+" msec")
          SetClassLong_(WindowID(),#GCL_HCURSOR,0)
          CompilerEndIf
          
          
        Else
          If ValidNumber(NR1.s)=0:MessageRequester("INFO","NO VALID NUMBER 1 :",0):EndIf
            If ValidNumber(NR2.s)=0:MessageRequester("INFO","NO VALID NUMBER 2 :",0):EndIf
            EndIf
          EndIf
        EndIf
      Until EventID = #PB_EventCloseWindow
    EndIf
    CompilerIf #OS = #Win
    DestroyCursor_(cur1)
    CompilerEndIf
    
    End
    
    ; ExecutableFormat=
    ; Executable=D:\Programme\PureBasic\BigNumbers.exe
; IDE Options = PureBasic v3.94 (Windows - x86)
; EnableXP
; DisableDebugger
; HideErrorLog