;
; Remoting Acrobat reader via DDE
;
; (C) 2005 Siegfried Rings
;
; More Infos about Acrobat Reader and DDE find 
; here: http://partners.adobe.com/public/developer/en/acrobat/sdk/pdf/iac/IACReference.pdf


; German: DDE Acrobat Fernsteuern
; Mehr zu DDE und Acrobat hier: http://partners.adobe.com/public/developer/en/acrobat/sdk/pdf/iac/IACReference.pdf
;
Global AdobeHwnd.l

Procedure ListWindows2FindAcrobat (window, parameter) 
 Dummy.s=Space(256)
 GetWindowText_ (window, @Dummy.s, 255)
 If FindString(Dummy.s,"Acrobat Reader",1)>0: AdobeHwnd.l=Window:EndIf
 If FindString(Dummy.s,"Adobe Acrobat",1)>0:AdobeHwnd.l=Window:EndIf
 If FindString(Dummy.s,"Adobe Reader",1)>0:AdobeHwnd.l=Window:EndIf
 If  AdobeHwnd.l=Window
  ProcedureReturn #False
 Else
 ProcedureReturn #TRUE 
 EndIf    
EndProcedure 


 PdfFile.s=""
 PdfFile.s="Test.pdf"

 If FileSize(PdfFile)<1 
  PdfFile.s=OpenFileRequester("Choose PDF-File to Print",PDFFile.s,"Portable Document File PDF|*.pdf",0) 
 EndIf

 If FileSize(PdfFile)<1 
  Beep_(1000,1000)
  End
 EndIf 

 Acrobat.s=GetExeNameFromSuffix("pdf")
 v=MessageRequester("Question","Show (Yes) or Print quitly (NO) the PDF= "+PDFFile.s,20)

 If v=6
  Result=ShellExecute_(0, "open", Acrobat.s,PdfFile.s,"",#SW_MAXIMIZE)    
  End
 EndIf
 
 Result=ShellExecute_(0, "open", Acrobat,"","",#SW_MINIMIZE)    
 Delay(2000);Wait a bit

 ;Now check for the Windows-title
 EnumWindows_ (@ListWindows2FindAcrobat (), 0)
 If AdobeHwnd.l=0
  Debug "Acrobat Reader not started ?"
 EndIf
 
 Timeout=30000; 30 secons before dde_execute  returns
 
 Cmd.s = "[FilePrintSilent(" + Chr(34) +PdfFile+Chr(34)+ ")]" ;remember To add "" around the filename!
 If DDE_Execute( "acroview", "control",Cmd,timeout)<>0
  Debug "DDE Execute sended"
 Else
  Debug "Cannot Send!"
 EndIf

 result=DDE_Execute("acroview", "control","[AppExit()]", Timeout)
 MessageRequester("Info","DDE-Exited",0)
 SendMessage_(Adobehwnd,#WM_CLOSE,0,0);Manual Close, not needed

End


; ExecutableFormat=Windows
; CursorPosition=29
; FirstLine=13
; EOF