;PB Servicemanager by RINGS 22.04.2004
; with a huge of Help from PWS32
 
; ListIconGagdet column header images 
; with image switching from Danilo, 
; 
Enumeration
  #List
  #Text
  #ButtonStart
  #ButtonSTOP
  #ButtonPAUSE
  #ButtonRESUME
  #ButtonRefreshList
  #ServiceControll
  #ServiceStatusBar
EndEnumeration
#Language=0
Global SearchService.s
CompilerIf #Language=0
#starting=" wird gestartet" 
#Stopping=" wird gestoppt"
#Pausing=" wird angehalten"
#Resume=" luft wieder an"
#Paused="angehalten"
#Started="gestartet"
#Stopped="beendet"
#ServiceName="Dienstname"
#Description="Anzeigename"
#DescriptionEx="Beschreibung"
#SelService = " ausgewhlter"
CompilerElse
#starting=" is starting" 
#Stopping=" is stopping"
#Pausing=" is pausing"
#Resume=" is resuming"
#Paused="pausing"
#Started="started"
#Stopped="stopped"
#ServiceName="Service Name"
#Description="Description"
#DescriptionEx="detailed Description"
#SelService = " selected"
CompilerEndIf
 
 
Procedure CreateListIconArrows(StartImage) 
  For img = 0 To 1 
    CreateImage(StartImage+img,16,16) 
    StartDrawing(ImageOutput()) 
    background = GetSysColor_(#COLOR_BTNFACE) 
    FrontColor(Red(background),Green(background),Blue(background)) 
    Box(0,0,16,16) 
    If img = 0 : start=7 : Else : start = 2 : EndIf 
    For a = 6 To 10 
      Line(start,a,13-start*2,0,0) 
      start+1 
    Next a 
    StopDrawing() 
  Next 
EndProcedure 
 
 
Procedure AddListIconColumn(Gadget,pos,width,align,text$,hImage) 
  ; by Danilo, 11.01.2004 
  ; 
  ; Add column to ListIconGadget 
  ; 
  ;   gadget = the PB gadget number 
  ;   pos    = position of the new column 
  ;   width  = with     of the new column 
  ;   align  = align    of the text in the column: 
  ;            #LI_CENTERED, #LI_LEFT, #LI_RIGHT 
  ;   text$  = column header text 
  ;   hImage = image handle __OR__ index of already added image! 
  ; 
  #LVCF_IMAGE = $10 
  #LVCFMT_COL_HAS_IMAGES = $8000 
  #LI_CENTERED = #LVCFMT_CENTER 
  #LI_LEFT     = #LVCFMT_LEFT 
  #LI_RIGHT    = #LVCFMT_RIGHT 
  Structure LVCOLUMN 
    lv.LV_COLUMN 
    iImage.l 
    iOrder.l 
  EndStructure 
  If GetObjectType_(hImage)=#OBJ_BITMAP 
    ; Add Image to List 
    hImgL = SendMessage_(GadgetID(Gadget),#LVM_GETIMAGELIST,#LVSIL_SMALL,0) 
    If hImgL=0 
      hImgL = ImageList_Create_(16,16,#ILC_COLOR32,1,1) 
      SendMessage_(GadgetID(Gadget),#LVM_SETIMAGELIST,#LVSIL_SMALL,hImgL) 
    EndIf 
    idx = ImageList_Add_(hImgL,hImage,0) 
  Else 
    ; was an index 
    idx = hImage 
  EndIf 
  LVC.LVCOLUMN 
  LVC\lv\mask = #LVCF_IMAGE|#LVCF_TEXT|#LVCF_WIDTH|#LVCF_FMT 
  LVC\lv\fmt     = align|#LVCFMT_COL_HAS_IMAGES 
  LVC\lv\pszText = @text$ 
  LVC\lv\cchTextMax = Len(text$) 
  LVC\lv\iSubItem = pos 
  LVC\lv\cx   = width 
  LVC\iImage  = idx 
  LVC\iOrder  = pos 
  SendMessage_(GadgetID(Gadget),#LVM_INSERTCOLUMN,pos,@LVC) 
EndProcedure 
 
 
Procedure GetListIconColumnImage(Gadget,column) 
  ; by Danilo, 11.01.2004 
  ; 
  ; returns the image_index of the column-header-image 
  ; 
  LVC.LVCOLUMN 
  LVC\lv\mask = #LVCF_IMAGE 
  SendMessage_(GadgetID(Gadget),#LVM_GETCOLUMN,column,@LVC) 
  ProcedureReturn LVC\iImage 
EndProcedure 
 
 
Procedure ChangeListIconColumnImage(Gadget,column,Image_Index) 
  ; by Danilo, 11.01.2004 
  ; 
  ; change the image_index of the column-header-image 
  ; 
  LVC.LVCOLUMN 
  LVC\lv\mask = #LVCF_IMAGE 
  LVC\iImage  = Image_Index 
  ProcedureReturn SendMessage_(GadgetID(Gadget),#LVM_SETCOLUMN,column,@LVC) 
EndProcedure 
 
 
Procedure SetListIconColumnText(Gadget,index,text$) 
  ; by Danilo, 15.12.2003 - english chat (for 'Karbon') 
  ; 
  ; change column header text 
  ; 
  LVC.LV_COLUMN 
  LVC\mask    = #LVCF_TEXT 
  LVC\pszText = @text$ 
  SendMessage_(GadgetID(Gadget),#LVM_SETCOLUMN,index,@LVC) 
EndProcedure 
 
 
Procedure SetListIconColumnWidth(Gadget,index,new_width) 
  ; by Danilo, 15.12.2003 - english chat (for 'Karbon') 
  ; 
  ; change column header width 
  ; 
  SendMessage_(GadgetID(Gadget),#LVM_SETCOLUMNWIDTH,index,new_width) 
EndProcedure 
 
 
Procedure SetListIconColumnFormat(Gadget,index,format) 
  ; by Danilo, 15.12.2003 - english chat (for 'Karbon') 
  ; 
  ; change text alignment for columns 
  ; 
  LVC.LV_COLUMN 
  LVC\mask = #LVCF_FMT 
  Select format 
    Case 0: LVC\fmt = #LVCFMT_LEFT 
    Case 1: LVC\fmt = #LVCFMT_CENTER 
    Case 2: LVC\fmt = #LVCFMT_RIGHT 
  EndSelect 
  SendMessage_(GadgetID(Gadget),#LVM_SETCOLUMN,index,@LVC) 
EndProcedure 
 
 
 
 
Procedure UpdatelParam(ListIconGadget,columns) 
  ; 
  ; PureArea.net CodeArchiv, by unknown 
  ; 
  ; modified by Danilo, 11.01.2004 
  ; 
  ItemCount = SendMessage_(ListIconGadget, #LVM_GETITEMCOUNT, 0, 0) 
  lvi.LV_ITEM 
  lvi\mask = #LVIF_PARAM 
  lvi\iItem = 0 
  While ItemCount>0 
    lvi\lParam = lvi\iItem 
    For SubItem = 0 To columns-1 
      lvi\iSubItem = SubItem 
      SendMessage_(ListIconGadget, #LVM_SETITEM, 0, @lvi) 
    Next SubItem 
    lvi\iItem +1 
    ItemCount -1 
  Wend 
EndProcedure 
 
Procedure SetList(sname.s)
  
  
EndProcedure
 
Procedure ListIconSortFunction(lParam1,lParam2,lParamSort) 
  ; 
  ; PureArea.net CodeArchiv, by unknown 
  ; 
  ; modified by Danilo, 11.01.2004 
  ; 
  a$ = Space(200) 
  B$ = Space(200) 
  Result = 0 
  lvi.LV_ITEM 
  lvi\iSubItem = lParamSort&$FFFF 
  lvi\pszText = @a$ 
  lvi\cchTextMax = 200 
  lvi\mask = #LVIF_TEXT 
  SendMessage_(GadgetID(#List), #LVM_GETITEMTEXT,lParam1,@lvi) 
  lvi\pszText = @B$ 
  SendMessage_(GadgetID(#List), #LVM_GETITEMTEXT,lParam2,@lvi) 
  
  If a$ = B$ 
    ProcedureReturn 0 ; equal 
  EndIf 
  
  x = (lParamSort>>16)&$FFFF 
  If x 
    If a$ > B$ 
      ProcedureReturn  1 
    Else 
      ProcedureReturn -1 
    EndIf 
  Else 
    If a$ > B$ 
      ProcedureReturn -1 
    Else 
      ProcedureReturn  1 
    EndIf 
  EndIf 
  ProcedureReturn Result 
EndProcedure 
; 
;- Window Callback 
; 
Procedure WinProc(hWnd,Msg,wParam,lParam) 
  Result = #PB_ProcessPureBasicEvents 
  Select Msg 
    Case #WM_SIZE ; Update all Gadgets by Resize
 
      ResizeGadget(#List, -1, -1, WindowWidth(), WindowHeight()-60)
Delay(2)

     ResizeGadget(#ServiceControll,-1,WindowHeight()-50,-1,-1)
Delay(2)

 ;     ResizeGadget(#ServiceControll,-1,WindowHeight()-80,-1,-1)
      newsize.l=WindowWidth()-400
      quadsize.l=newsize / 4
      SendMessage_(GadgetID(#List),#LVM_SETCOLUMNWIDTH,1,100+quadsize)
      SendMessage_(GadgetID(#List),#LVM_SETCOLUMNWIDTH,2,100+quadsize)
      SendMessage_(GadgetID(#List),#LVM_SETCOLUMNWIDTH,3,100+quadsize*2)
;      ResizeGadget(#ServiceControll,-1,WindowHeight()-80,-1,-1)

;       SendMessage_(GadgetID(#List),#LVM_SETCOLUMNWIDTH,4,100+WindowWidth())
      ActivateGadget(#List)
    Case #WM_NOTIFY 
      *NMHDR.NMHDR = lParam 
      If *NMHDR\hWndFrom = GadgetID(#List) ; comes from our ListIconGadget 
        If *NMHDR\code = #LVN_COLUMNCLICK 
          *NMLV.NMLISTVIEW = lParam 
          column = *NMLV\iSubItem 
          index  = GetListIconColumnImage(#List,column) 
          ChangeListIconColumnImage(#List,column,index!1) 
          SendMessage_(GadgetID(#List),#LVM_SORTITEMS,column|((index!1)<<16),@ListIconSortFunction()) 
          UpdatelParam(GadgetID(#List),5) 
        EndIf 
      EndIf 
  EndSelect 
  ProcedureReturn Result 
EndProcedure 
 
Procedure RefreshServiceList(OldSName.s)
  DisableGadget(#ButtonStart,1)
  DisableGadget(#ButtonSTOP,1)
  DisableGadget(#ButtonPAUSE,1)
  DisableGadget(#ButtonRESUME,1)
  ClearGadgetItemList(#List) 
  anzahl.l=ExamimeServices()
  While NextServices()>0
    sname.s = GetServiceName()
    DescriptionEx.s=GetServiceDescriptionEx(sname.s )
    Debug DescriptionEx
    sdesc.s = GetServiceDescription()
    Select GetServiceStatus()
      Case 1:stat.s = #Stopped
      Case 4:stat.s = #Started 
      Default
        stat.s =#Paused
    EndSelect
    ServiceEntry.s =sdesc+ Chr(10)+sdesc+Chr(10)+sname+Chr(10)+DescriptionEx+Chr(10)+stat
    ;Debug  ServiceEntry
    AddGadgetItem(#List,-1,ServiceEntry) 
    If OldSName.s=sname.s
      Oldg=p
    EndIf
    p+1 
  Wend
  Debug Oldg
  SetGadgetState(#List,Oldg)
  UpdatelParam(GadgetID(0),5) 
  SendMessage_(GadgetID(0),#LVM_SORTITEMS,1|((index|1)<<16),@ListIconSortFunction())     
  UpdatelParam(GadgetID(0),5) 
EndProcedure

Procedure InitList()
  RefreshServiceList("")
  SetGadgetState(#List,0)  
  SearchService = GetGadgetItemText(#List, GetGadgetState(#List), 0)
  SelectedService.s = GetGadgetItemText(#List, GetGadgetState(#List), 1)
  StatusBarText(#ServiceStatusBar, 0, #SelService +  " Service : " + SelectedService)

  ServiceStatus$ = GetGadgetItemText(#List, GetGadgetState(#List), 4)
  Select ServiceStatus$
    Case #Paused
      DisableGadget(#ButtonRESUME,0)
    Case #Started
      DisableGadget(#ButtonSTOP,0)
      DisableGadget(#ButtonPAUSE,0)
    Case #Stopped
      DisableGadget(#ButtonStart,0)
  EndSelect   
EndProcedure

Procedure FindStringLIG(searchString.s) 

  SendMessage_(GadgetID(#List), #LVM_FIRST + $54, $8, 1) 

  fItem.LV_FINDINFO 
  fItem\flags   = #LVFI_STRING 
  fItem\psz     = @searchString 

  itemNumber = SendMessage_(GadgetID(#List), #LVM_FINDITEM, -1, fItem) ; find Item 

  Debug "itemNumber = " +Str(itemNumber)
  If itemNumber > -1 
    Goto SCROLL_AND_SELECT 
  Else 
    For i = 0 To CountGadgetItems(#List) - 1 
      If searchString = GetGadgetItemText(#List, i, 0) 
        itemNumber = i 
        Goto SCROLL_AND_SELECT 
      EndIf 
    Next 
  EndIf 
  
  Goto PROC_ERROR 

  SCROLL_AND_SELECT: 
    pItem.POINT 

    SendMessage_(GadgetID(#List), #LVM_GETITEMPOSITION, itemNumber , pItem) ; get item position 
    SendMessage_(GadgetID(#List), #LVM_SCROLL, pItem\x, pItem\y -80)     ; scroll to item position 

    sItem.LV_ITEM 
    sItem\mask      = #LVIF_STATE 
    sItem\state     = #LVIS_SELECTED 
    sItem\stateMask = #LVIS_SELECTED 

    SendMessage_(GadgetID(#List), #LVM_SETITEMSTATE, itemNumber , sItem)    ; set item state as selected      
    Goto PROC_END 
  
  PROC_ERROR: 
    MessageRequester("Fehler", "Eintrag '" + searchString + "' nicht gedunden :(", #MB_ICONEXCLAMATION | #MB_OK)  

  PROC_END: 
EndProcedure 
; 
;- program start 
; 
CreateListIconArrows(0) 
#WIN=0
OpenWindow(#WIN,0,0,400,270,#PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget |#PB_Window_MaximizeGadget,"PB Service Manager") 
;SetWindowCallback(@WinProc()) 
If CreateGadgetList(WindowID())
  ListIconGadget(#List,0,0,400,210,"",0,#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection|#PB_ListIcon_GridLines) 
  AddListIconColumn(#List,0,0,#LI_LEFT    ,"",0) 
  AddListIconColumn(#List,1,100,#LI_LEFT    ,#Description,UseImage(1)) ; add Image 0 
  AddListIconColumn(#List,2,100,#LI_LEFT,#ServiceName,UseImage(0)) ; add Image 1 
  AddListIconColumn(#List,3,100,#LI_LEFT,#DescriptionEx,UseImage(1)) ; add Image 1 
  AddListIconColumn(#List,4,78,#LI_LEFT,"Status",UseImage(0))           ; use Image index 0 
  ChangeListIconColumnImage(#List,1,1)
  ChangeListIconColumnImage(#List,3,1)
  CreateStatusBar(#ServiceStatusBar, WindowID()) 
  AddStatusBarField(9000) 
  StatusBarText(#ServiceStatusBar, 0, " Service : ")
EndIf

ContainerGadget(#ServiceControll,0,220,480,20) 
;  TextGadget(#Text, 10, 1,480,20,"Service : ",#PB_Text_Border) 
  ButtonGadget(#ButtonStart,10,1,60,20,"START")
  ButtonGadget(#ButtonSTOP,80,1,60,20,"STOP")
  ButtonGadget(#ButtonPAUSE,150,1,60,20,"PAUSE")
  ButtonGadget(#ButtonRESUME,220,1,60,20,"RESUME")
  ButtonGadget(#ButtonRefreshList,290,1,80,20,"Refresh List")
CloseGadgetList()

SetWindowCallback(@WinProc()) 

InitList()

Repeat
  EventID = WaitWindowEvent() 
  
  Select EventID 
    Case #PB_Event_Gadget 
      
      Select EventGadgetID() 
        Case #List  
          DisableGadget(#ButtonStart,1)
          DisableGadget(#ButtonSTOP,1)
          DisableGadget(#ButtonPAUSE,1)
          DisableGadget(#ButtonRESUME,1)
          SearchService = GetGadgetItemText(#List, GetGadgetState(#List), 0)
          SelectedService.s = GetGadgetItemText(#List, GetGadgetState(#List), 2)
          StatusBarText(#ServiceStatusBar, 0, #SelService +  " Service : " +SelectedService)
          ServiceStatus$ = GetGadgetItemText(#List, GetGadgetState(#List), 4)
          Select ServiceStatus$
            Case #Paused
              DisableGadget(#ButtonRESUME,0)
            Case #Started
              DisableGadget(#ButtonSTOP,0)
              DisableGadget(#ButtonPAUSE,0)
            Case #Stopped
              DisableGadget(#ButtonStart,0)
          EndSelect  
        Case #ButtonStart
          StartService(SelectedService)
          StatusBarText(#ServiceStatusBar, 0, #SelService +  " Service : " +SelectedService+#starting)
          Delay(1000)
          RefreshServiceList(SelectedService)
          FindStringLIG(SearchService)
        Case #ButtonSTOP
          StopService(SelectedService)
          StatusBarText(#ServiceStatusBar, 0, #SelService +  " Service : " +SelectedService+#Stopping)
          Delay(1000)
          RefreshServiceList(SelectedService)
          FindStringLIG(SearchService)
        Case #ButtonPAUSE
          PauseService(SelectedService)
          StatusBarText(#ServiceStatusBar, 0, #SelService + " Service : " +SelectedService+#Pausing)
          Delay(1000)
          RefreshServiceList(SelectedService)
          FindStringLIG(SearchService)
        Case #ButtonRESUME
          ResumeService(SelectedService)
          StatusBarText(#ServiceStatusBar, 0, #SelService + " Service : " +SelectedService+#Resume)
          Delay(1000)
          RefreshServiceList(SelectedService)
          FindStringLIG(SearchService)
        Case #ButtonRefreshList
          RefreshServiceList(SelectedService)
          FindStringLIG(SearchService)
      EndSelect 
  EndSelect 
  
  If EventID = #PB_Event_CloseWindow
    Quit = 1
  EndIf
  
Until Quit = 1
End

; ExecutableFormat=Windows
; CursorPosition=287
; FirstLine=242
; EOF