;
; Create a Window and a Toolbar
;
#WinStyle = #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget
hWnd = OpenWindow(0, (GetSystemMetrics_(#SM_CXSCREEN)-800)/2,(GetSystemMetrics_(#SM_CYSCREEN)-277)/2, 600, 277, #WinStyle, "Toolbar by Danilo")
CreateTB(0,hWnd,50,39)                            ; Create the Toolbar
  Image1 = LoadImage(1,"TB.BMP")                  ; Load the Buttons
  Image2 = LoadImage(2,"TBMASK.BMP")              ; Load the Mask (for Transparency)
  Image3 = LoadImage(3,"HOT.BMP")                 ; Load the Hotspot Image
  SetTBimage(Image1,Image2,#TBpro_NORMAL)         ; Set the 2 Images for the Toolbar
  SetTBimage(Image3,Image2,#TBpro_HOT)

;
; Add some buttons
;
    AddTBbutton(1,1,#TBpro_Button)                ; 3 standard Buttons
    AddTBbutton(2,2,#TBpro_Button)
    AddTBbutton(3,3,#TBpro_Button)
       AddTBseparator()                           ;   Separator
       AddTBseparator()
    AddTBbutton(4,1,#TBpro_CheckButton)           ;   CheckButton
    AddTBbutton(5,2,#TBpro_CheckButton)           ;   (this is a group like a RadioButton)
    AddTBbutton(6,3,#TBpro_CheckButton)
       AddTBseparator()
    AddTBbutton(7,1,#TBpro_DropdownButton)        ;   DropDownButton
       AddTBseparator(0)
    AddTBbutton(8,2,#TBpro_PushButton)            ;   simple Pushbutton
    AddTBbutton(9,3,#TBpro_PushButton)            ;   (flips the state)

;
; Tooltips.... you know
;
  SetTBbuttonTooltip(1,"ImageButton 1")                                         ; Now lets set
  SetTBbuttonTooltip(2,"ImageButton 2")                                         ; the Tooltips for
  SetTBbuttonTooltip(3,"ImageButton 3"+Chr(10)+"changes If you press Button 2") ; all Buttons
  SetTBbuttonTooltip(4,"CHECK Button 1")                                        ; (you can change it every time)
  SetTBbuttonTooltip(5,"CHECK Button 2")
  SetTBbuttonTooltip(6,"CHECK Button 3")
  SetTBbuttonTooltip(7,"Dropdown Button")
  SetTBbuttonTooltip(8,"PUSH Button 1")
  SetTBbuttonTooltip(9,"PUSH Button 2")

;
; Exit Button
;
  If CreateGadgetList(hWnd)
     ButtonGadget(0, TBwidth()/2-30, TBheight(), 60, 25, "Quit")
  EndIf

;
; Main Loop
;
  Repeat
         Select WaitWindowEvent()
            Case #PB_EventGadget
                 Select EventGadgetID()
                   Case 0                            ; EXIT
                        End
                 EndSelect
            Case #PB_EventMenu
                 Select EventMenuID()
                   ;
                   ; Check the Toolbar Buttons
                   ;
                   Case 1                            ; Here you can react If
                        Beep_(200,50)                ; a Toolbar Button is pressed
                   Case 2
                        Beep_(400,50)
                        SetTBbuttonTooltip(3,"CLICK!")
                   Case 3
                        Beep_(600,50)
                   Case 4
                        Beep_(800,50)
                   Case 5
                        Beep_(1000,50)
                   Case 6
                        Beep_(1200,50)
                   Case 7
                        Beep_(1400,50)
                   Case 8
                        Beep_(1600,50)
                   Case 9
                        Beep_(1800,50)
                 EndSelect
            ; pressed CloseButton or ALT+F4 ??
            Case #PB_EventCloseWindow
                 End
         EndSelect
         ;
         ; Check for MouseOver on the Toolbar
         ;
         x = MouseOverTBbutton()
         If x
            SetGadgetText(0,"Button "+Str(x))
         Else
            SetGadgetText(0,"Quit")
         EndIf
  ForEver
 
; ExecutableFormat=Windows
; EnableAsm
; Executable=ImageButton 02.exe
; DisableDebugger
; EOF